/* CameraView.c generated by valac 0.48.13, the Vala compiler
 * generated from CameraView.vala, do not modify */

/*
 * Copyright (c) 2011-2019 elementary, inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Marcus Wichelmann <marcus.wichelmann@hotmail.de>
 *              Corentin Noël <corentin@elementary.io>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <granite.h>
#include <gst/gst.h>
#include <gst/video/video.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <gst/pbutils/pbutils.h>
#include <canberra.h>

#define CAMERA_WIDGETS_TYPE_CAMERA_VIEW (camera_widgets_camera_view_get_type ())
#define CAMERA_WIDGETS_CAMERA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CAMERA_WIDGETS_TYPE_CAMERA_VIEW, CameraWidgetsCameraView))
#define CAMERA_WIDGETS_CAMERA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CAMERA_WIDGETS_TYPE_CAMERA_VIEW, CameraWidgetsCameraViewClass))
#define CAMERA_WIDGETS_IS_CAMERA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CAMERA_WIDGETS_TYPE_CAMERA_VIEW))
#define CAMERA_WIDGETS_IS_CAMERA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CAMERA_WIDGETS_TYPE_CAMERA_VIEW))
#define CAMERA_WIDGETS_CAMERA_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CAMERA_WIDGETS_TYPE_CAMERA_VIEW, CameraWidgetsCameraViewClass))

typedef struct _CameraWidgetsCameraView CameraWidgetsCameraView;
typedef struct _CameraWidgetsCameraViewClass CameraWidgetsCameraViewClass;
typedef struct _CameraWidgetsCameraViewPrivate CameraWidgetsCameraViewPrivate;
enum  {
	CAMERA_WIDGETS_CAMERA_VIEW_0_PROPERTY,
	CAMERA_WIDGETS_CAMERA_VIEW_RECORDING_PROPERTY,
	CAMERA_WIDGETS_CAMERA_VIEW_HORIZONTAL_FLIP_PROPERTY,
	CAMERA_WIDGETS_CAMERA_VIEW_NUM_PROPERTIES
};
static GParamSpec* camera_widgets_camera_view_properties[CAMERA_WIDGETS_CAMERA_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _gst_structure_free0(var) ((var == NULL) ? NULL : (var = (gst_structure_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block2Data Block2Data;
typedef enum  {
	CAMERA_UTILS_ACTION_TYPE_PHOTO,
	CAMERA_UTILS_ACTION_TYPE_VIDEO
} CameraUtilsActionType;

#define CAMERA_UTILS_TYPE_ACTION_TYPE (camera_utils_action_type_get_type ())
#define _ca_context_destroy0(var) ((var == NULL) ? NULL : (var = (ca_context_destroy (var), NULL)))
#define _ca_proplist_destroy0(var) ((var == NULL) ? NULL : (var = (ca_proplist_destroy (var), NULL)))
#define _gst_caps_unref0(var) ((var == NULL) ? NULL : (var = (gst_caps_unref (var), NULL)))
enum  {
	CAMERA_WIDGETS_CAMERA_VIEW_CAMERA_ADDED_SIGNAL,
	CAMERA_WIDGETS_CAMERA_VIEW_CAMERA_REMOVED_SIGNAL,
	CAMERA_WIDGETS_CAMERA_VIEW_NUM_SIGNALS
};
static guint camera_widgets_camera_view_signals[CAMERA_WIDGETS_CAMERA_VIEW_NUM_SIGNALS] = {0};

struct _CameraWidgetsCameraView {
	GtkStack parent_instance;
	CameraWidgetsCameraViewPrivate * priv;
};

struct _CameraWidgetsCameraViewClass {
	GtkStackClass parent_class;
};

struct _CameraWidgetsCameraViewPrivate {
	GtkGrid* status_grid;
	GraniteWidgetsAlertView* no_device_view;
	GtkLabel* status_label;
	GtkWidget* gst_video_widget;
	GstPipeline* pipeline;
	GstElement* tee;
	GstColorBalance* color_balance;
	GstVideoDirection* hflip;
	GstBin* record_bin;
	GstDeviceMonitor* monitor;
	GPtrArray* cameras;
	gboolean _recording;
};

struct _Block2Data {
	int _ref_count_;
	CameraWidgetsCameraView* self;
	GstBin* snap_bin;
};

static gint CameraWidgetsCameraView_private_offset;
static gpointer camera_widgets_camera_view_parent_class = NULL;

GType camera_widgets_camera_view_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CameraWidgetsCameraView, g_object_unref)
static void _g_object_unref0_ (gpointer var);
static void camera_widgets_camera_view_on_device_added (CameraWidgetsCameraView* self,
                                                 GstDevice* device);
void camera_widgets_camera_view_start_view (CameraWidgetsCameraView* self,
                                            gint camera_number);
void camera_widgets_camera_view_change_camera (CameraWidgetsCameraView* self,
                                               gint camera_number);
static gboolean camera_widgets_camera_view_on_bus_message (CameraWidgetsCameraView* self,
                                                    GstBus* bus,
                                                    GstMessage* message);
void camera_widgets_camera_view_start (CameraWidgetsCameraView* self);
static void __lambda4_ (CameraWidgetsCameraView* self,
                 GstDevice* dev);
static void ___lambda4__gfunc (gconstpointer data,
                        gpointer self);
static inline void _g_list_free__g_object_unref0_ (GList* self);
gboolean camera_widgets_camera_view_get_recording (CameraWidgetsCameraView* self);
void camera_widgets_camera_view_stop_recording (CameraWidgetsCameraView* self);
static void camera_widgets_camera_view_create_pipeline (CameraWidgetsCameraView* self,
                                                 GstDevice* camera);
void camera_widgets_camera_view_change_color_balance (CameraWidgetsCameraView* self,
                                                      gdouble brightnesss,
                                                      gdouble contrast);
void camera_widgets_camera_view_take_photo (CameraWidgetsCameraView* self);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void camera_widgets_camera_view_set_recording (CameraWidgetsCameraView* self,
                                               gboolean value);
static void _vala_array_add1 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add2 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add3 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add4 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
GType camera_utils_action_type_get_type (void) G_GNUC_CONST;
gchar* camera_utils_get_new_media_filename (CameraUtilsActionType action_type);
static GstPadProbeReturn ___lambda5_ (Block2Data* _data2_,
                               GstPad* pad,
                               GstPadProbeInfo* info);
static gboolean __lambda6_ (Block2Data* _data2_);
static gboolean ___lambda6__gsource_func (gpointer self);
static GstPadProbeReturn ____lambda5__gst_pad_probe_callback (GstPad* pad,
                                                       GstPadProbeInfo* info,
                                                       gpointer self);
static void ___lambda7_ (CameraWidgetsCameraView* self,
                  GstInstallPluginsReturn _result_);
static void ____lambda7__gst_install_plugins_result_func (GstInstallPluginsReturn _result_,
                                                   gpointer self);
static void camera_widgets_camera_view_play_shutter_sound (void);
void camera_widgets_camera_view_start_recording (CameraWidgetsCameraView* self);
static void _vala_array_add5 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add6 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add7 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add8 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void ___lambda8_ (CameraWidgetsCameraView* self,
                  GstInstallPluginsReturn _result_);
static void ____lambda8__gst_install_plugins_result_func (GstInstallPluginsReturn _result_,
                                                   gpointer self);
CameraWidgetsCameraView* camera_widgets_camera_view_new (void);
CameraWidgetsCameraView* camera_widgets_camera_view_construct (GType object_type);
gboolean camera_widgets_camera_view_get_horizontal_flip (CameraWidgetsCameraView* self);
void camera_widgets_camera_view_set_horizontal_flip (CameraWidgetsCameraView* self,
                                                     gboolean value);
static GObject * camera_widgets_camera_view_constructor (GType type,
                                                  guint n_construct_properties,
                                                  GObjectConstructParam * construct_properties);
static gboolean _camera_widgets_camera_view_on_bus_message_gst_bus_func (GstBus* bus,
                                                                  GstMessage* message,
                                                                  gpointer self);
static void camera_widgets_camera_view_finalize (GObject * obj);
static GType camera_widgets_camera_view_get_type_once (void);
static void _vala_camera_widgets_camera_view_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec);
static void _vala_camera_widgets_camera_view_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
camera_widgets_camera_view_get_instance_private (CameraWidgetsCameraView* self)
{
	return G_STRUCT_MEMBER_P (self, CameraWidgetsCameraView_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

static gint
vala_g_ptr_array_get_length (GPtrArray* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = (gint) self->len;
	return result;
}

static void
camera_widgets_camera_view_on_device_added (CameraWidgetsCameraView* self,
                                            GstDevice* device)
{
	GPtrArray* _tmp0_;
	GstDevice* _tmp1_;
	GPtrArray* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (device != NULL);
	g_signal_emit (self, camera_widgets_camera_view_signals[CAMERA_WIDGETS_CAMERA_VIEW_CAMERA_ADDED_SIGNAL], 0, device);
	_tmp0_ = self->priv->cameras;
	_tmp1_ = device;
	device = NULL;
	g_ptr_array_add (_tmp0_, _tmp1_);
	_tmp2_ = self->priv->cameras;
	_tmp3_ = vala_g_ptr_array_get_length (_tmp2_);
	_tmp4_ = _tmp3_;
	if (_tmp4_ == 1) {
		GPtrArray* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		_tmp5_ = self->priv->cameras;
		_tmp6_ = vala_g_ptr_array_get_length (_tmp5_);
		_tmp7_ = _tmp6_;
		camera_widgets_camera_view_start_view (self, _tmp7_ - 1);
	} else {
		GPtrArray* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		_tmp8_ = self->priv->cameras;
		_tmp9_ = vala_g_ptr_array_get_length (_tmp8_);
		_tmp10_ = _tmp9_;
		camera_widgets_camera_view_change_camera (self, _tmp10_ - 1);
	}
	_g_object_unref0 (device);
}

static gboolean
camera_widgets_camera_view_on_bus_message (CameraWidgetsCameraView* self,
                                           GstBus* bus,
                                           GstMessage* message)
{
	GstMessageType _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (bus != NULL, FALSE);
	g_return_val_if_fail (message != NULL, FALSE);
	_tmp0_ = message->type;
	switch (_tmp0_) {
		case GST_MESSAGE_DEVICE_ADDED:
		{
			GstDevice* device = NULL;
			GstDevice* _tmp1_ = NULL;
			GstDevice* _tmp2_;
			gst_message_parse_device_added (message, &_tmp1_);
			_g_object_unref0 (device);
			device = _tmp1_;
			_tmp2_ = device;
			device = NULL;
			camera_widgets_camera_view_on_device_added (self, _tmp2_);
			_g_object_unref0 (device);
			break;
		}
		case GST_MESSAGE_DEVICE_CHANGED:
		{
			GstDevice* device = NULL;
			GstDevice* changed_device = NULL;
			GstDevice* _tmp3_ = NULL;
			GstDevice* _tmp4_ = NULL;
			GPtrArray* _tmp5_;
			GstDevice* _tmp6_;
			GstDevice* _tmp7_;
			GPtrArray* _tmp8_;
			GstDevice* _tmp9_;
			gst_message_parse_device_changed (message, &_tmp3_, &_tmp4_);
			_g_object_unref0 (device);
			device = _tmp3_;
			_g_object_unref0 (changed_device);
			changed_device = _tmp4_;
			_tmp5_ = self->priv->cameras;
			_tmp6_ = changed_device;
			changed_device = NULL;
			_tmp7_ = _tmp6_;
			g_ptr_array_remove (_tmp5_, _tmp7_);
			_g_object_unref0 (_tmp7_);
			_tmp8_ = self->priv->cameras;
			_tmp9_ = device;
			device = NULL;
			g_ptr_array_add (_tmp8_, _tmp9_);
			_g_object_unref0 (changed_device);
			_g_object_unref0 (device);
			break;
		}
		case GST_MESSAGE_DEVICE_REMOVED:
		{
			GstDevice* device = NULL;
			GstDevice* _tmp10_ = NULL;
			GstDevice* _tmp11_;
			GPtrArray* _tmp12_;
			GstDevice* _tmp13_;
			GstDevice* _tmp14_;
			GPtrArray* _tmp15_;
			gint _tmp16_;
			gint _tmp17_;
			gst_message_parse_device_removed (message, &_tmp10_);
			_g_object_unref0 (device);
			device = _tmp10_;
			_tmp11_ = device;
			g_signal_emit (self, camera_widgets_camera_view_signals[CAMERA_WIDGETS_CAMERA_VIEW_CAMERA_REMOVED_SIGNAL], 0, _tmp11_);
			_tmp12_ = self->priv->cameras;
			_tmp13_ = device;
			device = NULL;
			_tmp14_ = _tmp13_;
			g_ptr_array_remove (_tmp12_, _tmp14_);
			_g_object_unref0 (_tmp14_);
			_tmp15_ = self->priv->cameras;
			_tmp16_ = vala_g_ptr_array_get_length (_tmp15_);
			_tmp17_ = _tmp16_;
			if (_tmp17_ == 0) {
				GraniteWidgetsAlertView* _tmp18_;
				_tmp18_ = self->priv->no_device_view;
				gtk_stack_set_visible_child ((GtkStack*) self, (GtkWidget*) _tmp18_);
			} else {
				camera_widgets_camera_view_change_camera (self, 0);
			}
			_g_object_unref0 (device);
			break;
		}
		default:
		{
			break;
		}
	}
	result = G_SOURCE_CONTINUE;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
__lambda4_ (CameraWidgetsCameraView* self,
            GstDevice* dev)
{
	GstDevice* _tmp0_;
	g_return_if_fail (dev != NULL);
	_tmp0_ = _g_object_ref0 (dev);
	camera_widgets_camera_view_on_device_added (self, _tmp0_);
}

static void
___lambda4__gfunc (gconstpointer data,
                   gpointer self)
{
	__lambda4_ ((CameraWidgetsCameraView*) self, (GstDevice*) data);
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
}

void
camera_widgets_camera_view_start (CameraWidgetsCameraView* self)
{
	GstDeviceMonitor* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	GstDeviceMonitor* _tmp3_;
	GPtrArray* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->monitor;
	_tmp1_ = gst_device_monitor_get_devices (_tmp0_);
	_tmp2_ = _tmp1_;
	g_list_foreach (_tmp2_, ___lambda4__gfunc, self);
	(_tmp2_ == NULL) ? NULL : (_tmp2_ = (_g_list_free__g_object_unref0_ (_tmp2_), NULL));
	_tmp3_ = self->priv->monitor;
	gst_device_monitor_start (_tmp3_);
	_tmp4_ = self->priv->cameras;
	_tmp5_ = vala_g_ptr_array_get_length (_tmp4_);
	_tmp6_ = _tmp5_;
	if (_tmp6_ == 0) {
		GraniteWidgetsAlertView* _tmp7_;
		_tmp7_ = self->priv->no_device_view;
		gtk_stack_set_visible_child ((GtkStack*) self, (GtkWidget*) _tmp7_);
	}
}

void
camera_widgets_camera_view_change_camera (CameraWidgetsCameraView* self,
                                          gint camera_number)
{
	gboolean _tmp0_;
	GstBin* _tmp1_;
	GstPipeline* _tmp5_;
	GstPipeline* _tmp6_;
	GstPipeline* _tmp7_;
	GPtrArray* _tmp8_;
	gconstpointer _tmp9_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_recording;
	if (_tmp0_) {
		camera_widgets_camera_view_stop_recording (self);
	}
	_tmp1_ = self->priv->record_bin;
	if (_tmp1_ != NULL) {
		GstBin* _tmp2_;
		GstBin* _tmp3_;
		GstBin* _tmp4_;
		_tmp2_ = self->priv->record_bin;
		gst_element_set_state ((GstElement*) _tmp2_, GST_STATE_NULL);
		_tmp3_ = self->priv->record_bin;
		gst_element_sync_state_with_parent ((GstElement*) _tmp3_);
		_tmp4_ = self->priv->record_bin;
		gst_bin_sync_children_states (_tmp4_);
	}
	_tmp5_ = self->priv->pipeline;
	gst_element_set_state ((GstElement*) _tmp5_, GST_STATE_NULL);
	_tmp6_ = self->priv->pipeline;
	gst_bin_sync_children_states ((GstBin*) _tmp6_);
	_tmp7_ = self->priv->pipeline;
	GST_DEBUG_BIN_TO_DOT_FILE ((GstBin*) _tmp7_, GST_DEBUG_GRAPH_SHOW_VERBOSE, "changing");
	_tmp8_ = self->priv->cameras;
	_tmp9_ = g_ptr_array_index (_tmp8_, (guint) camera_number);
	camera_widgets_camera_view_create_pipeline (self, (GstDevice*) _tmp9_);
}

static void
camera_widgets_camera_view_create_pipeline (CameraWidgetsCameraView* self,
                                            GstDevice* camera)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (camera != NULL);
	{
		GstElement* _tmp0_ = NULL;
		GstStructure* _tmp1_;
		GstStructure* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		GstElement* _tmp22_;
		GstElement* _tmp23_;
		GstPipeline* _tmp24_;
		GstPipeline* _tmp25_;
		GstElement* _tmp26_;
		GstPipeline* _tmp27_;
		GstElement* _tmp28_;
		GstVideoDirection* _tmp29_;
		GstPipeline* _tmp30_;
		GstElement* _tmp31_;
		GstColorBalance* _tmp32_;
		GstElement* gtksink = NULL;
		GstPipeline* _tmp33_;
		GstElement* _tmp34_;
		GstElement* _tmp35_;
		GtkWidget* _tmp36_ = NULL;
		GtkWidget* _tmp37_;
		GtkWidget* _tmp39_;
		GtkWidget* _tmp40_;
		GtkWidget* _tmp41_;
		GstPipeline* _tmp42_;
		_tmp1_ = gst_device_get_properties (camera);
		_tmp2_ = _tmp1_;
		_tmp3_ = gst_structure_get_string (_tmp2_, "device.path");
		_tmp4_ = g_strdup_printf ("v4l2src device=%s name=v4l2src !", _tmp3_);
		_tmp5_ = _tmp4_;
		_tmp6_ = g_strconcat (_tmp5_, "video/x-raw, width=640, height=480, framerate=30/1 ! ", NULL);
		_tmp7_ = _tmp6_;
		_tmp8_ = g_strconcat (_tmp7_, "videoflip method=horizontal-flip name=hflip ! ", NULL);
		_tmp9_ = _tmp8_;
		_tmp10_ = g_strconcat (_tmp9_, "videobalance name=balance ! ", NULL);
		_tmp11_ = _tmp10_;
		_tmp12_ = g_strconcat (_tmp11_, "tee name=tee ! ", NULL);
		_tmp13_ = _tmp12_;
		_tmp14_ = g_strconcat (_tmp13_, "queue leaky=downstream max-size-buffers=10 ! ", NULL);
		_tmp15_ = _tmp14_;
		_tmp16_ = g_strconcat (_tmp15_, "videoconvert ! ", NULL);
		_tmp17_ = _tmp16_;
		_tmp18_ = g_strconcat (_tmp17_, "videoscale ! ", NULL);
		_tmp19_ = _tmp18_;
		_tmp20_ = g_strconcat (_tmp19_, "gtksink name=gtksink", NULL);
		_tmp21_ = _tmp20_;
		_tmp22_ = gst_parse_launch_full (_tmp21_, NULL, GST_PARSE_FLAG_NONE, &_inner_error0_);
		if (_tmp22_ != NULL) {
			g_object_ref_sink (_tmp22_);
		}
		_tmp23_ = _tmp22_;
		_g_free0 (_tmp21_);
		_g_free0 (_tmp19_);
		_g_free0 (_tmp17_);
		_g_free0 (_tmp15_);
		_g_free0 (_tmp13_);
		_g_free0 (_tmp11_);
		_g_free0 (_tmp9_);
		_g_free0 (_tmp7_);
		_g_free0 (_tmp5_);
		_gst_structure_free0 (_tmp2_);
		_tmp0_ = _tmp23_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp24_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gst_pipeline_get_type (), GstPipeline));
		_g_object_unref0 (self->priv->pipeline);
		self->priv->pipeline = _tmp24_;
		_tmp25_ = self->priv->pipeline;
		_tmp26_ = gst_bin_get_by_name ((GstBin*) _tmp25_, "tee");
		_g_object_unref0 (self->priv->tee);
		self->priv->tee = _tmp26_;
		_tmp27_ = self->priv->pipeline;
		_tmp28_ = gst_bin_get_by_name ((GstBin*) _tmp27_, "hflip");
		_tmp29_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp28_, gst_video_direction_get_type ()) ? ((GstVideoDirection*) _tmp28_) : NULL;
		if (_tmp29_ == NULL) {
			_g_object_unref0 (_tmp28_);
		}
		_g_object_unref0 (self->priv->hflip);
		self->priv->hflip = _tmp29_;
		_tmp30_ = self->priv->pipeline;
		_tmp31_ = gst_bin_get_by_name ((GstBin*) _tmp30_, "balance");
		_tmp32_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp31_, gst_color_balance_get_type ()) ? ((GstColorBalance*) _tmp31_) : NULL;
		if (_tmp32_ == NULL) {
			_g_object_unref0 (_tmp31_);
		}
		_g_object_unref0 (self->priv->color_balance);
		self->priv->color_balance = _tmp32_;
		_tmp33_ = self->priv->pipeline;
		_tmp34_ = gst_bin_get_by_name ((GstBin*) _tmp33_, "gtksink");
		gtksink = _tmp34_;
		_tmp35_ = gtksink;
		g_object_get ((GObject*) _tmp35_, "widget", &_tmp36_, NULL);
		_g_object_unref0 (self->priv->gst_video_widget);
		self->priv->gst_video_widget = _tmp36_;
		_tmp37_ = self->priv->gst_video_widget;
		if (_tmp37_ != NULL) {
			GtkWidget* _tmp38_;
			_tmp38_ = self->priv->gst_video_widget;
			gtk_container_remove ((GtkContainer*) self, _tmp38_);
		}
		_tmp39_ = self->priv->gst_video_widget;
		gtk_container_add ((GtkContainer*) self, _tmp39_);
		_tmp40_ = self->priv->gst_video_widget;
		gtk_widget_show (_tmp40_);
		_tmp41_ = self->priv->gst_video_widget;
		gtk_stack_set_visible_child ((GtkStack*) self, _tmp41_);
		_tmp42_ = self->priv->pipeline;
		gst_element_set_state ((GstElement*) _tmp42_, GST_STATE_PLAYING);
		_g_object_unref0 (gtksink);
		_g_object_unref0 (_tmp0_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GraniteWidgetsAlertView* _tmp43_;
		GraniteMessageDialog* dialog = NULL;
		GError* _tmp44_;
		const gchar* _tmp45_;
		GraniteMessageDialog* _tmp46_;
		GraniteMessageDialog* _tmp47_;
		GraniteMessageDialog* _tmp48_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp43_ = self->priv->no_device_view;
		gtk_stack_set_visible_child ((GtkStack*) self, (GtkWidget*) _tmp43_);
		_tmp44_ = e;
		_tmp45_ = _tmp44_->message;
		_tmp46_ = granite_message_dialog_new_with_image_from_icon_name (_ ("Unable To View Camera"), _tmp45_, "dialog-error", GTK_BUTTONS_CLOSE);
		g_object_ref_sink (_tmp46_);
		dialog = _tmp46_;
		_tmp47_ = dialog;
		gtk_dialog_run ((GtkDialog*) _tmp47_);
		_tmp48_ = dialog;
		gtk_widget_destroy ((GtkWidget*) _tmp48_);
		_g_object_unref0 (dialog);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

void
camera_widgets_camera_view_change_color_balance (CameraWidgetsCameraView* self,
                                                 gdouble brightnesss,
                                                 gdouble contrast)
{
	GstColorBalance* _tmp0_;
	GValue _tmp1_ = {0};
	GstColorBalance* _tmp2_;
	GValue _tmp3_ = {0};
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->color_balance;
	g_value_init (&_tmp1_, G_TYPE_DOUBLE);
	g_value_set_double (&_tmp1_, brightnesss);
	g_object_set_property ((GObject*) _tmp0_, "brightness", &_tmp1_);
	G_IS_VALUE (&_tmp1_) ? (g_value_unset (&_tmp1_), NULL) : NULL;
	_tmp2_ = self->priv->color_balance;
	g_value_init (&_tmp3_, G_TYPE_DOUBLE);
	g_value_set_double (&_tmp3_, contrast);
	g_object_set_property ((GObject*) _tmp2_, "contrast", &_tmp3_);
	G_IS_VALUE (&_tmp3_) ? (g_value_unset (&_tmp3_), NULL) : NULL;
}

void
camera_widgets_camera_view_start_view (CameraWidgetsCameraView* self,
                                       gint camera_number)
{
	GstDevice* camera = NULL;
	GPtrArray* _tmp0_;
	gconstpointer _tmp1_;
	GtkGrid* _tmp2_;
	GtkLabel* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->cameras;
	_tmp1_ = g_ptr_array_index (_tmp0_, (guint) camera_number);
	camera = (GstDevice*) _tmp1_;
	_tmp2_ = self->priv->status_grid;
	gtk_stack_set_visible_child ((GtkStack*) self, (GtkWidget*) _tmp2_);
	_tmp3_ = self->priv->status_label;
	_tmp4_ = gst_device_get_display_name (camera);
	_tmp5_ = _tmp4_;
	_tmp6_ = _tmp5_;
	_tmp7_ = g_strdup_printf (_ ("Connecting to \"%s\"…"), _tmp6_);
	_tmp8_ = _tmp7_;
	gtk_label_set_label (_tmp3_, _tmp8_);
	_g_free0 (_tmp8_);
	_g_free0 (_tmp6_);
	camera_widgets_camera_view_create_pipeline (self, camera);
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		CameraWidgetsCameraView* self;
		self = _data2_->self;
		_g_object_unref0 (_data2_->snap_bin);
		_g_object_unref0 (self);
		g_slice_free (Block2Data, _data2_);
	}
}

static void
_vala_array_add1 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add2 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add3 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add4 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static gboolean
__lambda6_ (Block2Data* _data2_)
{
	CameraWidgetsCameraView* self;
	GstPipeline* _tmp0_;
	GstBin* _tmp1_;
	GstBin* _tmp2_;
	GstPipeline* _tmp3_;
	GstBin* _tmp4_;
	GstPipeline* _tmp5_;
	gboolean result = FALSE;
	self = _data2_->self;
	_tmp0_ = self->priv->pipeline;
	gst_element_set_state ((GstElement*) _tmp0_, GST_STATE_PAUSED);
	_tmp1_ = _data2_->snap_bin;
	gst_element_set_state ((GstElement*) _tmp1_, GST_STATE_NULL);
	_tmp2_ = _data2_->snap_bin;
	gst_bin_sync_children_states (_tmp2_);
	_tmp3_ = self->priv->pipeline;
	_tmp4_ = _data2_->snap_bin;
	gst_bin_remove ((GstBin*) _tmp3_, (GstElement*) _tmp4_);
	_tmp5_ = self->priv->pipeline;
	gst_element_set_state ((GstElement*) _tmp5_, GST_STATE_PLAYING);
	camera_widgets_camera_view_set_recording (self, FALSE);
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
___lambda6__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda6_ (self);
	return result;
}

static GstPadProbeReturn
___lambda5_ (Block2Data* _data2_,
             GstPad* pad,
             GstPadProbeInfo* info)
{
	CameraWidgetsCameraView* self;
	GstPadProbeReturn result = 0;
	self = _data2_->self;
	g_return_val_if_fail (pad != NULL, 0);
	g_return_val_if_fail (info != NULL, 0);
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 50, ___lambda6__gsource_func, block2_data_ref (_data2_), block2_data_unref);
	result = GST_PAD_PROBE_REMOVE;
	return result;
}

static GstPadProbeReturn
____lambda5__gst_pad_probe_callback (GstPad* pad,
                                     GstPadProbeInfo* info,
                                     gpointer self)
{
	GstPadProbeReturn result;
	result = ___lambda5_ (self, pad, info);
	return result;
}

static void
___lambda7_ (CameraWidgetsCameraView* self,
             GstInstallPluginsReturn _result_)
{
}

static void
____lambda7__gst_install_plugins_result_func (GstInstallPluginsReturn _result_,
                                              gpointer self)
{
	___lambda7_ ((CameraWidgetsCameraView*) self, _result_);
	g_object_unref (self);
}

void
camera_widgets_camera_view_take_photo (CameraWidgetsCameraView* self)
{
	Block2Data* _data2_;
	gboolean _tmp0_;
	GstBin* _tmp1_;
	gchar** missing_messages = NULL;
	gchar** _tmp2_;
	gint missing_messages_length1;
	gint _missing_messages_size_;
	GstElement* queue = NULL;
	GstElement* _tmp3_;
	GstElement* _tmp4_;
	GstElement* videoconvert = NULL;
	GstElement* _tmp6_;
	GstElement* _tmp7_;
	GstElement* encoder = NULL;
	GstElement* _tmp9_;
	GstElement* _tmp10_;
	GstElement* filesink = NULL;
	GstElement* _tmp12_;
	GstElement* _tmp13_;
	gchar** _tmp22_;
	gint _tmp22__length1;
	GstBin* _tmp24_;
	GstElement* _tmp25_;
	GstElement* _tmp26_;
	GstElement* _tmp27_;
	GstElement* _tmp28_;
	GstElement* _tmp29_;
	GstElement* _tmp30_;
	GstElement* _tmp31_;
	GstElement* _tmp32_;
	GstGhostPad* ghostpad = NULL;
	GstElement* _tmp33_;
	GstPad* _tmp34_;
	GstPad* _tmp35_;
	GstGhostPad* _tmp36_;
	GstGhostPad* _tmp37_;
	GstBin* _tmp38_;
	GstGhostPad* _tmp39_;
	GstPipeline* _tmp40_;
	GstPipeline* _tmp41_;
	GstBin* _tmp42_;
	GstBin* _tmp43_;
	GstElement* _tmp44_;
	GstBin* _tmp45_;
	GstPipeline* _tmp46_;
	GstPipeline* _tmp47_;
	g_return_if_fail (self != NULL);
	_data2_ = g_slice_new0 (Block2Data);
	_data2_->_ref_count_ = 1;
	_data2_->self = g_object_ref (self);
	_tmp0_ = self->priv->_recording;
	if (_tmp0_) {
		block2_data_unref (_data2_);
		_data2_ = NULL;
		return;
	}
	camera_widgets_camera_view_set_recording (self, TRUE);
	_tmp1_ = (GstBin*) gst_bin_new (NULL);
	g_object_ref_sink (_tmp1_);
	_data2_->snap_bin = _tmp1_;
	_tmp2_ = g_new0 (gchar*, 0 + 1);
	missing_messages = _tmp2_;
	missing_messages_length1 = 0;
	_missing_messages_size_ = missing_messages_length1;
	_tmp3_ = gst_element_factory_make ("queue", NULL);
	if (_tmp3_ != NULL) {
		g_object_ref_sink (_tmp3_);
	}
	queue = _tmp3_;
	_tmp4_ = queue;
	if (_tmp4_ == NULL) {
		gchar* _tmp5_;
		_tmp5_ = gst_missing_element_installer_detail_new ("queue");
		_vala_array_add1 (&missing_messages, &missing_messages_length1, &_missing_messages_size_, _tmp5_);
	}
	_tmp6_ = gst_element_factory_make ("videoconvert", NULL);
	if (_tmp6_ != NULL) {
		g_object_ref_sink (_tmp6_);
	}
	videoconvert = _tmp6_;
	_tmp7_ = videoconvert;
	if (_tmp7_ == NULL) {
		gchar* _tmp8_;
		_tmp8_ = gst_missing_element_installer_detail_new ("videoconvert");
		_vala_array_add2 (&missing_messages, &missing_messages_length1, &_missing_messages_size_, _tmp8_);
	}
	_tmp9_ = gst_element_factory_make ("jpegenc", NULL);
	if (_tmp9_ != NULL) {
		g_object_ref_sink (_tmp9_);
	}
	encoder = _tmp9_;
	_tmp10_ = encoder;
	if (_tmp10_ == NULL) {
		gchar* _tmp11_;
		_tmp11_ = gst_missing_element_installer_detail_new ("jpegenc");
		_vala_array_add3 (&missing_messages, &missing_messages_length1, &_missing_messages_size_, _tmp11_);
	}
	_tmp12_ = gst_element_factory_make ("filesink", NULL);
	if (_tmp12_ != NULL) {
		g_object_ref_sink (_tmp12_);
	}
	filesink = _tmp12_;
	_tmp13_ = filesink;
	if (_tmp13_ == NULL) {
		gchar* _tmp14_;
		_tmp14_ = gst_missing_element_installer_detail_new ("filesink");
		_vala_array_add4 (&missing_messages, &missing_messages_length1, &_missing_messages_size_, _tmp14_);
	} else {
		GstElement* _tmp15_;
		GstElement* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		GstElement* _tmp19_;
		GstPad* _tmp20_;
		GstPad* _tmp21_;
		_tmp15_ = filesink;
		g_object_set ((GObject*) _tmp15_, "buffer-size", 1, NULL);
		_tmp16_ = filesink;
		_tmp17_ = camera_utils_get_new_media_filename (CAMERA_UTILS_ACTION_TYPE_PHOTO);
		_tmp18_ = _tmp17_;
		g_object_set ((GObject*) _tmp16_, "location", _tmp18_, NULL);
		_g_free0 (_tmp18_);
		_tmp19_ = filesink;
		_tmp20_ = gst_element_get_static_pad (_tmp19_, "sink");
		_tmp21_ = _tmp20_;
		gst_pad_add_probe (_tmp21_, GST_PAD_PROBE_TYPE_BUFFER, ____lambda5__gst_pad_probe_callback, block2_data_ref (_data2_), block2_data_unref);
		_g_object_unref0 (_tmp21_);
	}
	_tmp22_ = missing_messages;
	_tmp22__length1 = missing_messages_length1;
	if (_tmp22__length1 > 0) {
		gchar** _tmp23_;
		gint _tmp23__length1;
		_tmp23_ = missing_messages;
		_tmp23__length1 = missing_messages_length1;
		gst_install_plugins_async (_tmp23_, NULL, ____lambda7__gst_install_plugins_result_func, g_object_ref (self));
		camera_widgets_camera_view_set_recording (self, FALSE);
		_g_object_unref0 (filesink);
		_g_object_unref0 (encoder);
		_g_object_unref0 (videoconvert);
		_g_object_unref0 (queue);
		missing_messages = (_vala_array_free (missing_messages, missing_messages_length1, (GDestroyNotify) g_free), NULL);
		block2_data_unref (_data2_);
		_data2_ = NULL;
		return;
	}
	_tmp24_ = _data2_->snap_bin;
	_tmp25_ = queue;
	_tmp26_ = videoconvert;
	_tmp27_ = encoder;
	_tmp28_ = filesink;
	gst_bin_add_many (_tmp24_, _tmp25_, _tmp26_, _tmp27_, _tmp28_, NULL);
	_tmp29_ = queue;
	_tmp30_ = videoconvert;
	_tmp31_ = encoder;
	_tmp32_ = filesink;
	gst_element_link_many (_tmp29_, _tmp30_, _tmp31_, _tmp32_, NULL);
	_tmp33_ = queue;
	_tmp34_ = gst_element_get_static_pad (_tmp33_, "sink");
	_tmp35_ = _tmp34_;
	_tmp36_ = (GstGhostPad*) gst_ghost_pad_new (NULL, _tmp35_);
	g_object_ref_sink (_tmp36_);
	_tmp37_ = _tmp36_;
	_g_object_unref0 (_tmp35_);
	ghostpad = _tmp37_;
	_tmp38_ = _data2_->snap_bin;
	_tmp39_ = ghostpad;
	gst_element_add_pad ((GstElement*) _tmp38_, (GstPad*) _tmp39_);
	_tmp40_ = self->priv->pipeline;
	gst_element_set_state ((GstElement*) _tmp40_, GST_STATE_PAUSED);
	_tmp41_ = self->priv->pipeline;
	_tmp42_ = _data2_->snap_bin;
	gst_bin_add ((GstBin*) _tmp41_, (GstElement*) _tmp42_);
	_tmp43_ = _data2_->snap_bin;
	gst_element_sync_state_with_parent ((GstElement*) _tmp43_);
	_tmp44_ = self->priv->tee;
	_tmp45_ = _data2_->snap_bin;
	gst_element_link (_tmp44_, (GstElement*) _tmp45_);
	_tmp46_ = self->priv->pipeline;
	gst_element_set_state ((GstElement*) _tmp46_, GST_STATE_PLAYING);
	_tmp47_ = self->priv->pipeline;
	GST_DEBUG_BIN_TO_DOT_FILE ((GstBin*) _tmp47_, GST_DEBUG_GRAPH_SHOW_VERBOSE, "snapshot");
	camera_widgets_camera_view_play_shutter_sound ();
	_g_object_unref0 (ghostpad);
	_g_object_unref0 (filesink);
	_g_object_unref0 (encoder);
	_g_object_unref0 (videoconvert);
	_g_object_unref0 (queue);
	missing_messages = (_vala_array_free (missing_messages, missing_messages_length1, (GDestroyNotify) g_free), NULL);
	block2_data_unref (_data2_);
	_data2_ = NULL;
}

static void
_vala_array_add5 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add6 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add7 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add8 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
___lambda8_ (CameraWidgetsCameraView* self,
             GstInstallPluginsReturn _result_)
{
}

static void
____lambda8__gst_install_plugins_result_func (GstInstallPluginsReturn _result_,
                                              gpointer self)
{
	___lambda8_ ((CameraWidgetsCameraView*) self, _result_);
	g_object_unref (self);
}

void
camera_widgets_camera_view_start_recording (CameraWidgetsCameraView* self)
{
	gboolean _tmp0_;
	GstBin* _tmp1_;
	gchar** missing_messages = NULL;
	gchar** _tmp2_;
	gint missing_messages_length1;
	gint _missing_messages_size_;
	GstElement* queue = NULL;
	GstElement* _tmp3_;
	GstElement* videoconvert = NULL;
	GstElement* _tmp4_;
	GstElement* _tmp5_;
	GstElement* encoder = NULL;
	GstElement* _tmp7_;
	GstElement* _tmp8_;
	GstElement* muxer = NULL;
	GstElement* _tmp10_;
	GstElement* _tmp11_;
	GstElement* filesink = NULL;
	GstElement* _tmp13_;
	GstElement* _tmp14_;
	gchar** _tmp19_;
	gint _tmp19__length1;
	GstBin* _tmp21_;
	GstElement* _tmp22_;
	GstElement* _tmp23_;
	GstElement* _tmp24_;
	GstElement* _tmp25_;
	GstElement* _tmp26_;
	GstElement* _tmp27_;
	GstElement* _tmp28_;
	GstElement* _tmp29_;
	GstElement* _tmp30_;
	GstElement* _tmp31_;
	GstGhostPad* ghostpad = NULL;
	GstElement* _tmp32_;
	GstPad* _tmp33_;
	GstPad* _tmp34_;
	GstGhostPad* _tmp35_;
	GstGhostPad* _tmp36_;
	GstBin* _tmp37_;
	GstGhostPad* _tmp38_;
	GstPipeline* _tmp39_;
	GstPipeline* _tmp40_;
	GstBin* _tmp41_;
	GstBin* _tmp42_;
	GstElement* _tmp43_;
	GstBin* _tmp44_;
	GstPipeline* _tmp45_;
	GstPipeline* _tmp46_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_recording;
	if (_tmp0_) {
		return;
	}
	camera_widgets_camera_view_set_recording (self, TRUE);
	_tmp1_ = (GstBin*) gst_bin_new (NULL);
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->priv->record_bin);
	self->priv->record_bin = _tmp1_;
	_tmp2_ = g_new0 (gchar*, 0 + 1);
	missing_messages = _tmp2_;
	missing_messages_length1 = 0;
	_missing_messages_size_ = missing_messages_length1;
	_tmp3_ = gst_element_factory_make ("queue", NULL);
	if (_tmp3_ != NULL) {
		g_object_ref_sink (_tmp3_);
	}
	queue = _tmp3_;
	_tmp4_ = gst_element_factory_make ("videoconvert", NULL);
	if (_tmp4_ != NULL) {
		g_object_ref_sink (_tmp4_);
	}
	videoconvert = _tmp4_;
	_tmp5_ = videoconvert;
	if (_tmp5_ == NULL) {
		gchar* _tmp6_;
		_tmp6_ = gst_missing_element_installer_detail_new ("videoconvert");
		_vala_array_add5 (&missing_messages, &missing_messages_length1, &_missing_messages_size_, _tmp6_);
	}
	_tmp7_ = gst_element_factory_make ("vp8enc", NULL);
	if (_tmp7_ != NULL) {
		g_object_ref_sink (_tmp7_);
	}
	encoder = _tmp7_;
	_tmp8_ = encoder;
	if (_tmp8_ == NULL) {
		gchar* _tmp9_;
		_tmp9_ = gst_missing_element_installer_detail_new ("vp8enc");
		_vala_array_add6 (&missing_messages, &missing_messages_length1, &_missing_messages_size_, _tmp9_);
	}
	_tmp10_ = gst_element_factory_make ("webmmux", NULL);
	if (_tmp10_ != NULL) {
		g_object_ref_sink (_tmp10_);
	}
	muxer = _tmp10_;
	_tmp11_ = muxer;
	if (_tmp11_ == NULL) {
		gchar* _tmp12_;
		_tmp12_ = gst_missing_element_installer_detail_new ("webmmux");
		_vala_array_add7 (&missing_messages, &missing_messages_length1, &_missing_messages_size_, _tmp12_);
	}
	_tmp13_ = gst_element_factory_make ("filesink", NULL);
	if (_tmp13_ != NULL) {
		g_object_ref_sink (_tmp13_);
	}
	filesink = _tmp13_;
	_tmp14_ = filesink;
	if (_tmp14_ == NULL) {
		gchar* _tmp15_;
		_tmp15_ = gst_missing_element_installer_detail_new ("filesink");
		_vala_array_add8 (&missing_messages, &missing_messages_length1, &_missing_messages_size_, _tmp15_);
	} else {
		GstElement* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		_tmp16_ = filesink;
		_tmp17_ = camera_utils_get_new_media_filename (CAMERA_UTILS_ACTION_TYPE_VIDEO);
		_tmp18_ = _tmp17_;
		g_object_set ((GObject*) _tmp16_, "location", _tmp18_, NULL);
		_g_free0 (_tmp18_);
	}
	_tmp19_ = missing_messages;
	_tmp19__length1 = missing_messages_length1;
	if (_tmp19__length1 > 0) {
		gchar** _tmp20_;
		gint _tmp20__length1;
		_tmp20_ = missing_messages;
		_tmp20__length1 = missing_messages_length1;
		gst_install_plugins_async (_tmp20_, NULL, ____lambda8__gst_install_plugins_result_func, g_object_ref (self));
		camera_widgets_camera_view_set_recording (self, FALSE);
		_g_object_unref0 (filesink);
		_g_object_unref0 (muxer);
		_g_object_unref0 (encoder);
		_g_object_unref0 (videoconvert);
		_g_object_unref0 (queue);
		missing_messages = (_vala_array_free (missing_messages, missing_messages_length1, (GDestroyNotify) g_free), NULL);
		return;
	}
	_tmp21_ = self->priv->record_bin;
	_tmp22_ = queue;
	_tmp23_ = videoconvert;
	_tmp24_ = encoder;
	_tmp25_ = muxer;
	_tmp26_ = filesink;
	gst_bin_add_many (_tmp21_, _tmp22_, _tmp23_, _tmp24_, _tmp25_, _tmp26_, NULL);
	_tmp27_ = queue;
	_tmp28_ = videoconvert;
	_tmp29_ = encoder;
	_tmp30_ = muxer;
	_tmp31_ = filesink;
	gst_element_link_many (_tmp27_, _tmp28_, _tmp29_, _tmp30_, _tmp31_, NULL);
	_tmp32_ = queue;
	_tmp33_ = gst_element_get_static_pad (_tmp32_, "sink");
	_tmp34_ = _tmp33_;
	_tmp35_ = (GstGhostPad*) gst_ghost_pad_new (NULL, _tmp34_);
	g_object_ref_sink (_tmp35_);
	_tmp36_ = _tmp35_;
	_g_object_unref0 (_tmp34_);
	ghostpad = _tmp36_;
	_tmp37_ = self->priv->record_bin;
	_tmp38_ = ghostpad;
	gst_element_add_pad ((GstElement*) _tmp37_, (GstPad*) _tmp38_);
	_tmp39_ = self->priv->pipeline;
	gst_element_set_state ((GstElement*) _tmp39_, GST_STATE_PAUSED);
	_tmp40_ = self->priv->pipeline;
	_tmp41_ = self->priv->record_bin;
	gst_bin_add ((GstBin*) _tmp40_, (GstElement*) _tmp41_);
	_tmp42_ = self->priv->record_bin;
	gst_element_sync_state_with_parent ((GstElement*) _tmp42_);
	_tmp43_ = self->priv->tee;
	_tmp44_ = self->priv->record_bin;
	gst_element_link (_tmp43_, (GstElement*) _tmp44_);
	_tmp45_ = self->priv->pipeline;
	gst_element_set_state ((GstElement*) _tmp45_, GST_STATE_PLAYING);
	_tmp46_ = self->priv->pipeline;
	GST_DEBUG_BIN_TO_DOT_FILE ((GstBin*) _tmp46_, GST_DEBUG_GRAPH_SHOW_VERBOSE, "recording");
	_g_object_unref0 (ghostpad);
	_g_object_unref0 (filesink);
	_g_object_unref0 (muxer);
	_g_object_unref0 (encoder);
	_g_object_unref0 (videoconvert);
	_g_object_unref0 (queue);
	missing_messages = (_vala_array_free (missing_messages, missing_messages_length1, (GDestroyNotify) g_free), NULL);
}

void
camera_widgets_camera_view_stop_recording (CameraWidgetsCameraView* self)
{
	gboolean _tmp0_;
	GstPipeline* _tmp1_;
	GstElement* _tmp2_;
	GstBin* _tmp3_;
	GstPipeline* _tmp4_;
	GstBin* _tmp5_;
	GstPipeline* _tmp6_;
	GstBin* _tmp7_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_recording;
	if (!_tmp0_) {
		return;
	}
	_tmp1_ = self->priv->pipeline;
	gst_element_set_state ((GstElement*) _tmp1_, GST_STATE_PAUSED);
	_tmp2_ = self->priv->tee;
	_tmp3_ = self->priv->record_bin;
	gst_element_unlink (_tmp2_, (GstElement*) _tmp3_);
	_tmp4_ = self->priv->pipeline;
	_tmp5_ = self->priv->record_bin;
	gst_bin_remove ((GstBin*) _tmp4_, (GstElement*) _tmp5_);
	_tmp6_ = self->priv->pipeline;
	gst_element_set_state ((GstElement*) _tmp6_, GST_STATE_PLAYING);
	_tmp7_ = self->priv->record_bin;
	gst_element_set_state ((GstElement*) _tmp7_, GST_STATE_PLAYING);
	camera_widgets_camera_view_set_recording (self, FALSE);
}

static void
camera_widgets_camera_view_play_shutter_sound (void)
{
	ca_context* context = NULL;
	ca_proplist* props = NULL;
	ca_context* _tmp0_ = NULL;
	ca_proplist* _tmp1_ = NULL;
	ca_context_create (&_tmp0_);
	_ca_context_destroy0 (context);
	context = _tmp0_;
	ca_proplist_create (&_tmp1_);
	_ca_proplist_destroy0 (props);
	props = _tmp1_;
	ca_proplist_sets (props, CA_PROP_EVENT_ID, "camera-shutter");
	ca_proplist_sets (props, CA_PROP_EVENT_DESCRIPTION, _ ("Photo taken"));
	ca_proplist_sets (props, CA_PROP_CANBERRA_CACHE_CONTROL, "permanent");
	ca_proplist_sets (props, CA_PROP_MEDIA_ROLE, "event");
	ca_context_play_full (context, (guint32) 0, props, NULL, NULL);
	_ca_proplist_destroy0 (props);
	_ca_context_destroy0 (context);
}

CameraWidgetsCameraView*
camera_widgets_camera_view_construct (GType object_type)
{
	CameraWidgetsCameraView * self = NULL;
	self = (CameraWidgetsCameraView*) g_object_new (object_type, NULL);
	return self;
}

CameraWidgetsCameraView*
camera_widgets_camera_view_new (void)
{
	return camera_widgets_camera_view_construct (CAMERA_WIDGETS_TYPE_CAMERA_VIEW);
}

gboolean
camera_widgets_camera_view_get_recording (CameraWidgetsCameraView* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_recording;
	return result;
}

static void
camera_widgets_camera_view_set_recording (CameraWidgetsCameraView* self,
                                          gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = camera_widgets_camera_view_get_recording (self);
	if (old_value != value) {
		self->priv->_recording = value;
		g_object_notify_by_pspec ((GObject *) self, camera_widgets_camera_view_properties[CAMERA_WIDGETS_CAMERA_VIEW_RECORDING_PROPERTY]);
	}
}

gboolean
camera_widgets_camera_view_get_horizontal_flip (CameraWidgetsCameraView* self)
{
	gboolean result;
	GstVideoDirection* _tmp0_;
	GstVideoDirection* _tmp1_;
	GstVideoOrientationMethod _tmp2_;
	GstVideoOrientationMethod _tmp3_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->hflip;
	if (_tmp0_ == NULL) {
		result = TRUE;
		return result;
	}
	_tmp1_ = self->priv->hflip;
	g_object_get (_tmp1_, "video-direction", &_tmp2_, NULL);
	_tmp3_ = _tmp2_;
	result = _tmp3_ == GST_VIDEO_ORIENTATION_HORIZ;
	return result;
}

void
camera_widgets_camera_view_set_horizontal_flip (CameraWidgetsCameraView* self,
                                                gboolean value)
{
	GstVideoDirection* _tmp0_;
	GstVideoDirection* _tmp1_;
	GstVideoOrientationMethod _tmp2_;
	GstVideoOrientationMethod _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->hflip;
	if (_tmp0_ == NULL) {
		return;
	}
	_tmp1_ = self->priv->hflip;
	g_object_get (_tmp1_, "video-direction", &_tmp2_, NULL);
	_tmp3_ = _tmp2_;
	if (_tmp3_ == GST_VIDEO_ORIENTATION_IDENTITY) {
		GstVideoDirection* _tmp4_;
		_tmp4_ = self->priv->hflip;
		g_object_set (_tmp4_, "video-direction", GST_VIDEO_ORIENTATION_HORIZ, NULL);
	} else {
		GstVideoDirection* _tmp5_;
		_tmp5_ = self->priv->hflip;
		g_object_set (_tmp5_, "video-direction", GST_VIDEO_ORIENTATION_IDENTITY, NULL);
	}
	g_object_notify_by_pspec ((GObject *) self, camera_widgets_camera_view_properties[CAMERA_WIDGETS_CAMERA_VIEW_HORIZONTAL_FLIP_PROPERTY]);
}

static gboolean
_camera_widgets_camera_view_on_bus_message_gst_bus_func (GstBus* bus,
                                                         GstMessage* message,
                                                         gpointer self)
{
	gboolean result;
	result = camera_widgets_camera_view_on_bus_message ((CameraWidgetsCameraView*) self, bus, message);
	return result;
}

static GObject *
camera_widgets_camera_view_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	CameraWidgetsCameraView * self;
	GtkSpinner* spinner = NULL;
	GtkSpinner* _tmp0_;
	GtkSpinner* _tmp1_;
	GtkLabel* _tmp2_;
	GtkGrid* _tmp3_ = NULL;
	GtkGrid* _tmp4_;
	GtkSpinner* _tmp5_;
	GtkGrid* _tmp6_;
	GtkLabel* _tmp7_;
	GraniteWidgetsAlertView* _tmp8_;
	GtkGrid* _tmp9_;
	GraniteWidgetsAlertView* _tmp10_;
	GstDeviceMonitor* _tmp11_;
	GstBus* _tmp12_;
	GstBus* _tmp13_;
	GstCaps* caps = NULL;
	GstCaps* _tmp14_;
	GstDeviceMonitor* _tmp15_;
	GstCaps* _tmp16_;
	parent_class = G_OBJECT_CLASS (camera_widgets_camera_view_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CAMERA_WIDGETS_TYPE_CAMERA_VIEW, CameraWidgetsCameraView);
	_tmp0_ = (GtkSpinner*) gtk_spinner_new ();
	g_object_ref_sink (_tmp0_);
	spinner = _tmp0_;
	_tmp1_ = spinner;
	g_object_set (_tmp1_, "active", TRUE, NULL);
	_tmp2_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp2_);
	_g_object_unref0 (self->priv->status_label);
	self->priv->status_label = _tmp2_;
	_tmp3_ = (GtkGrid*) gtk_grid_new ();
	gtk_grid_set_column_spacing (_tmp3_, 6);
	gtk_widget_set_halign ((GtkWidget*) _tmp3_, GTK_ALIGN_CENTER);
	gtk_widget_set_valign ((GtkWidget*) _tmp3_, GTK_ALIGN_CENTER);
	g_object_ref_sink (_tmp3_);
	_g_object_unref0 (self->priv->status_grid);
	self->priv->status_grid = _tmp3_;
	_tmp4_ = self->priv->status_grid;
	_tmp5_ = spinner;
	gtk_container_add ((GtkContainer*) _tmp4_, (GtkWidget*) _tmp5_);
	_tmp6_ = self->priv->status_grid;
	_tmp7_ = self->priv->status_label;
	gtk_container_add ((GtkContainer*) _tmp6_, (GtkWidget*) _tmp7_);
	_tmp8_ = granite_widgets_alert_view_new (_ ("No Supported Camera Found"), _ ("Connect a webcam or other supported video device to take photos and vi" \
"deo."), "");
	g_object_ref_sink (_tmp8_);
	_g_object_unref0 (self->priv->no_device_view);
	self->priv->no_device_view = _tmp8_;
	_tmp9_ = self->priv->status_grid;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp9_);
	_tmp10_ = self->priv->no_device_view;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp10_);
	_tmp11_ = self->priv->monitor;
	_tmp12_ = gst_device_monitor_get_bus (_tmp11_);
	_tmp13_ = _tmp12_;
	gst_bus_add_watch_full (_tmp13_, G_PRIORITY_DEFAULT, _camera_widgets_camera_view_on_bus_message_gst_bus_func, g_object_ref (self), g_object_unref);
	_g_object_unref0 (_tmp13_);
	_tmp14_ = gst_caps_new_empty_simple ("video/x-raw");
	caps = _tmp14_;
	_tmp15_ = self->priv->monitor;
	_tmp16_ = caps;
	gst_device_monitor_add_filter (_tmp15_, "Video/Source", _tmp16_);
	_gst_caps_unref0 (caps);
	_g_object_unref0 (spinner);
	return obj;
}

static void
camera_widgets_camera_view_class_init (CameraWidgetsCameraViewClass * klass,
                                       gpointer klass_data)
{
	camera_widgets_camera_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &CameraWidgetsCameraView_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_camera_widgets_camera_view_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_camera_widgets_camera_view_set_property;
	G_OBJECT_CLASS (klass)->constructor = camera_widgets_camera_view_constructor;
	G_OBJECT_CLASS (klass)->finalize = camera_widgets_camera_view_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), CAMERA_WIDGETS_CAMERA_VIEW_RECORDING_PROPERTY, camera_widgets_camera_view_properties[CAMERA_WIDGETS_CAMERA_VIEW_RECORDING_PROPERTY] = g_param_spec_boolean ("recording", "recording", "recording", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), CAMERA_WIDGETS_CAMERA_VIEW_HORIZONTAL_FLIP_PROPERTY, camera_widgets_camera_view_properties[CAMERA_WIDGETS_CAMERA_VIEW_HORIZONTAL_FLIP_PROPERTY] = g_param_spec_boolean ("horizontal-flip", "horizontal-flip", "horizontal-flip", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	camera_widgets_camera_view_signals[CAMERA_WIDGETS_CAMERA_VIEW_CAMERA_ADDED_SIGNAL] = g_signal_new ("camera-added", CAMERA_WIDGETS_TYPE_CAMERA_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gst_device_get_type ());
	camera_widgets_camera_view_signals[CAMERA_WIDGETS_CAMERA_VIEW_CAMERA_REMOVED_SIGNAL] = g_signal_new ("camera-removed", CAMERA_WIDGETS_TYPE_CAMERA_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gst_device_get_type ());
}

static void
camera_widgets_camera_view_instance_init (CameraWidgetsCameraView * self,
                                          gpointer klass)
{
	GstDeviceMonitor* _tmp0_;
	GPtrArray* _tmp1_;
	self->priv = camera_widgets_camera_view_get_instance_private (self);
	_tmp0_ = gst_device_monitor_new ();
	g_object_ref_sink (_tmp0_);
	self->priv->monitor = _tmp0_;
	_tmp1_ = g_ptr_array_new_full ((guint) 0, _g_object_unref0_);
	self->priv->cameras = _tmp1_;
	self->priv->_recording = FALSE;
}

static void
camera_widgets_camera_view_finalize (GObject * obj)
{
	CameraWidgetsCameraView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CAMERA_WIDGETS_TYPE_CAMERA_VIEW, CameraWidgetsCameraView);
	_g_object_unref0 (self->priv->status_grid);
	_g_object_unref0 (self->priv->no_device_view);
	_g_object_unref0 (self->priv->status_label);
	_g_object_unref0 (self->priv->gst_video_widget);
	_g_object_unref0 (self->priv->pipeline);
	_g_object_unref0 (self->priv->tee);
	_g_object_unref0 (self->priv->color_balance);
	_g_object_unref0 (self->priv->hflip);
	_g_object_unref0 (self->priv->record_bin);
	_g_object_unref0 (self->priv->monitor);
	_g_ptr_array_unref0 (self->priv->cameras);
	G_OBJECT_CLASS (camera_widgets_camera_view_parent_class)->finalize (obj);
}

static GType
camera_widgets_camera_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (CameraWidgetsCameraViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) camera_widgets_camera_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CameraWidgetsCameraView), 0, (GInstanceInitFunc) camera_widgets_camera_view_instance_init, NULL };
	GType camera_widgets_camera_view_type_id;
	camera_widgets_camera_view_type_id = g_type_register_static (gtk_stack_get_type (), "CameraWidgetsCameraView", &g_define_type_info, 0);
	CameraWidgetsCameraView_private_offset = g_type_add_instance_private (camera_widgets_camera_view_type_id, sizeof (CameraWidgetsCameraViewPrivate));
	return camera_widgets_camera_view_type_id;
}

GType
camera_widgets_camera_view_get_type (void)
{
	static volatile gsize camera_widgets_camera_view_type_id__volatile = 0;
	if (g_once_init_enter (&camera_widgets_camera_view_type_id__volatile)) {
		GType camera_widgets_camera_view_type_id;
		camera_widgets_camera_view_type_id = camera_widgets_camera_view_get_type_once ();
		g_once_init_leave (&camera_widgets_camera_view_type_id__volatile, camera_widgets_camera_view_type_id);
	}
	return camera_widgets_camera_view_type_id__volatile;
}

static void
_vala_camera_widgets_camera_view_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec)
{
	CameraWidgetsCameraView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CAMERA_WIDGETS_TYPE_CAMERA_VIEW, CameraWidgetsCameraView);
	switch (property_id) {
		case CAMERA_WIDGETS_CAMERA_VIEW_RECORDING_PROPERTY:
		g_value_set_boolean (value, camera_widgets_camera_view_get_recording (self));
		break;
		case CAMERA_WIDGETS_CAMERA_VIEW_HORIZONTAL_FLIP_PROPERTY:
		g_value_set_boolean (value, camera_widgets_camera_view_get_horizontal_flip (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_camera_widgets_camera_view_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec)
{
	CameraWidgetsCameraView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CAMERA_WIDGETS_TYPE_CAMERA_VIEW, CameraWidgetsCameraView);
	switch (property_id) {
		case CAMERA_WIDGETS_CAMERA_VIEW_RECORDING_PROPERTY:
		camera_widgets_camera_view_set_recording (self, g_value_get_boolean (value));
		break;
		case CAMERA_WIDGETS_CAMERA_VIEW_HORIZONTAL_FLIP_PROPERTY:
		camera_widgets_camera_view_set_horizontal_flip (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

