/* HeaderBar.c generated by valac 0.48.13, the Vala compiler
 * generated from HeaderBar.vala, do not modify */

/*
 * Copyright (c) 2011-2019 elementary, inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Marcus Wichelmann <marcus.wichelmann@hotmail.de>
 *              Corentin Noël <corentin@elementary.io>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <granite.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gst/gst.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <gio/gio.h>

#define CAMERA_WIDGETS_TYPE_HEADER_BAR (camera_widgets_header_bar_get_type ())
#define CAMERA_WIDGETS_HEADER_BAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CAMERA_WIDGETS_TYPE_HEADER_BAR, CameraWidgetsHeaderBar))
#define CAMERA_WIDGETS_HEADER_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CAMERA_WIDGETS_TYPE_HEADER_BAR, CameraWidgetsHeaderBarClass))
#define CAMERA_WIDGETS_IS_HEADER_BAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CAMERA_WIDGETS_TYPE_HEADER_BAR))
#define CAMERA_WIDGETS_IS_HEADER_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CAMERA_WIDGETS_TYPE_HEADER_BAR))
#define CAMERA_WIDGETS_HEADER_BAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CAMERA_WIDGETS_TYPE_HEADER_BAR, CameraWidgetsHeaderBarClass))

typedef struct _CameraWidgetsHeaderBar CameraWidgetsHeaderBar;
typedef struct _CameraWidgetsHeaderBarClass CameraWidgetsHeaderBarClass;
typedef struct _CameraWidgetsHeaderBarPrivate CameraWidgetsHeaderBarPrivate;

#define CAMERA_WIDGETS_TYPE_TIMER_BUTTON (camera_widgets_timer_button_get_type ())
#define CAMERA_WIDGETS_TIMER_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CAMERA_WIDGETS_TYPE_TIMER_BUTTON, CameraWidgetsTimerButton))
#define CAMERA_WIDGETS_TIMER_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CAMERA_WIDGETS_TYPE_TIMER_BUTTON, CameraWidgetsTimerButtonClass))
#define CAMERA_WIDGETS_IS_TIMER_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CAMERA_WIDGETS_TYPE_TIMER_BUTTON))
#define CAMERA_WIDGETS_IS_TIMER_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CAMERA_WIDGETS_TYPE_TIMER_BUTTON))
#define CAMERA_WIDGETS_TIMER_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CAMERA_WIDGETS_TYPE_TIMER_BUTTON, CameraWidgetsTimerButtonClass))

typedef struct _CameraWidgetsTimerButton CameraWidgetsTimerButton;
typedef struct _CameraWidgetsTimerButtonClass CameraWidgetsTimerButtonClass;
enum  {
	CAMERA_WIDGETS_HEADER_BAR_0_PROPERTY,
	CAMERA_WIDGETS_HEADER_BAR_RECORDING_PROPERTY,
	CAMERA_WIDGETS_HEADER_BAR_HORIZONTAL_FLIP_PROPERTY,
	CAMERA_WIDGETS_HEADER_BAR_TIMER_DELAY_PROPERTY,
	CAMERA_WIDGETS_HEADER_BAR_NUM_PROPERTIES
};
static GParamSpec* camera_widgets_header_bar_properties[CAMERA_WIDGETS_HEADER_BAR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block3Data Block3Data;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block4Data Block4Data;
typedef struct _Block5Data Block5Data;
typedef struct _CameraWidgetsTimerButtonPrivate CameraWidgetsTimerButtonPrivate;
typedef enum  {
	CAMERA_WIDGETS_TIMER_BUTTON_DELAY_DISABLED = 0,
	CAMERA_WIDGETS_TIMER_BUTTON_DELAY_3_SEC = 3,
	CAMERA_WIDGETS_TIMER_BUTTON_DELAY_5_SEC = 5,
	CAMERA_WIDGETS_TIMER_BUTTON_DELAY_10_SEC = 10
} CameraWidgetsTimerButtonDelay;

#define CAMERA_WIDGETS_TIMER_BUTTON_TYPE_DELAY (camera_widgets_timer_button_delay_get_type ())
typedef struct _Block6Data Block6Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef enum  {
	CAMERA_UTILS_ACTION_TYPE_PHOTO,
	CAMERA_UTILS_ACTION_TYPE_VIDEO
} CameraUtilsActionType;

#define CAMERA_UTILS_TYPE_ACTION_TYPE (camera_utils_action_type_get_type ())
enum  {
	CAMERA_WIDGETS_HEADER_BAR_REQUEST_CHANGE_BALANCE_SIGNAL,
	CAMERA_WIDGETS_HEADER_BAR_REQUEST_CAMERA_CHANGE_SIGNAL,
	CAMERA_WIDGETS_HEADER_BAR_NUM_SIGNALS
};
static guint camera_widgets_header_bar_signals[CAMERA_WIDGETS_HEADER_BAR_NUM_SIGNALS] = {0};

struct _CameraWidgetsHeaderBar {
	GtkHeaderBar parent_instance;
	CameraWidgetsHeaderBarPrivate * priv;
};

struct _CameraWidgetsHeaderBarClass {
	GtkHeaderBarClass parent_class;
};

struct _CameraWidgetsHeaderBarPrivate {
	CameraWidgetsTimerButton* timer_button;
	GtkRevealer* video_timer_revealer;
	GtkLabel* take_timer;
	GtkButton* take_button;
	GtkMenuButton* camera_menu_button;
	GtkRevealer* camera_menu_revealer;
	GtkMenu* camera_options;
	GtkImage* take_image;
	GraniteModeSwitch* mode_switch;
	gboolean _recording;
	gboolean _horizontal_flip;
	guint recording_timeout;
};

struct _Block3Data {
	int _ref_count_;
	CameraWidgetsHeaderBar* self;
	gint i;
};

struct _Block4Data {
	int _ref_count_;
	CameraWidgetsHeaderBar* self;
	gint time;
};

struct _Block5Data {
	int _ref_count_;
	CameraWidgetsHeaderBar* self;
	gint seconds;
};

struct _CameraWidgetsTimerButton {
	GtkButton parent_instance;
	CameraWidgetsTimerButtonPrivate * priv;
	CameraWidgetsTimerButtonDelay delay;
};

struct _CameraWidgetsTimerButtonClass {
	GtkButtonClass parent_class;
};

struct _Block6Data {
	int _ref_count_;
	CameraWidgetsHeaderBar* self;
	GtkSwitch* mirror_switch;
	GtkScale* brightness_scale;
	GtkScale* contrast_scale;
};

static gint CameraWidgetsHeaderBar_private_offset;
static gpointer camera_widgets_header_bar_parent_class = NULL;
extern GSettings* camera_application_settings;

GType camera_widgets_header_bar_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CameraWidgetsHeaderBar, g_object_unref)
GType camera_widgets_timer_button_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CameraWidgetsTimerButton, g_object_unref)
#define CAMERA_WIDGETS_HEADER_BAR_PHOTO_ICON_SYMBOLIC "view-list-images-symbolic"
#define CAMERA_WIDGETS_HEADER_BAR_VIDEO_ICON_SYMBOLIC "view-list-video-symbolic"
#define CAMERA_WIDGETS_HEADER_BAR_STOP_ICON_SYMBOLIC "media-playback-stop-symbolic"
#define CAMERA_WIDGETS_HEADER_BAR_TAKE_BUTTON_STYLESHEET "\n" \
"        .camera-menu {\n" \
"            border-radius: 0 400px 400px 0;\n" \
"        }\n" \
"\n" \
"        .take-button {\n" \
"            border-radius: 400px;\n" \
"            padding-left: 6px;\n" \
"            padding-right: 6px;\n" \
"            transition-duration: 200ms;\n" \
"            transition-property: border-top-right-radius, border-botto" \
"m-right-radius, padding-right;\n" \
"        }\n" \
"\n" \
"        .take-button.multiple {\n" \
"            border-bottom-right-radius: 0;\n" \
"            border-top-right-radius: 0;\n" \
"            border-right-width: 0;\n" \
"            padding-right: 0;\n" \
"        }\n" \
"    "
void camera_widgets_header_bar_add_camera_option (CameraWidgetsHeaderBar* self,
                                                  GstDevice* camera);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void __lambda10_ (Block3Data* _data3_);
static void ___lambda10__gtk_menu_item_activate (GtkMenuItem* _sender,
                                          gpointer self);
static void camera_widgets_header_bar_update_take_button (CameraWidgetsHeaderBar* self);
void camera_widgets_header_bar_remove_camera_option (CameraWidgetsHeaderBar* self,
                                                     GstDevice* camera);
void camera_widgets_header_bar_start_timeout (CameraWidgetsHeaderBar* self,
                                              gint time);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static gboolean ___lambda11_ (Block4Data* _data4_);
static gboolean ____lambda11__gsource_func (gpointer self);
void camera_widgets_header_bar_start_recording_time (CameraWidgetsHeaderBar* self);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
void camera_widgets_header_bar_set_recording (CameraWidgetsHeaderBar* self,
                                              gboolean value);
static gboolean __lambda12_ (Block5Data* _data5_);
static gboolean ___lambda12__gsource_func (gpointer self);
void camera_widgets_header_bar_stop_recording_time (CameraWidgetsHeaderBar* self);
CameraWidgetsHeaderBar* camera_widgets_header_bar_new (void);
CameraWidgetsHeaderBar* camera_widgets_header_bar_construct (GType object_type);
gboolean camera_widgets_header_bar_get_recording (CameraWidgetsHeaderBar* self);
gboolean camera_widgets_header_bar_get_horizontal_flip (CameraWidgetsHeaderBar* self);
void camera_widgets_header_bar_set_horizontal_flip (CameraWidgetsHeaderBar* self,
                                                    gboolean value);
gint camera_widgets_header_bar_get_timer_delay (CameraWidgetsHeaderBar* self);
GType camera_widgets_timer_button_delay_get_type (void) G_GNUC_CONST;
static void g_cclosure_user_marshal_VOID__DOUBLE_DOUBLE (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static GObject * camera_widgets_header_bar_constructor (GType type,
                                                 guint n_construct_properties,
                                                 GObjectConstructParam * construct_properties);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
CameraWidgetsTimerButton* camera_widgets_timer_button_new (void);
CameraWidgetsTimerButton* camera_widgets_timer_button_construct (GType object_type);
#define CAMERA_MAIN_WINDOW_ACTION_PREFIX "win."
#define CAMERA_MAIN_WINDOW_ACTION_TAKE_PHOTO "take_photo"
static gboolean _camera_widgets_header_bar___lambda13_ (Block6Data* _data6_);
static gboolean __camera_widgets_header_bar___lambda13__gtk_widget_button_release_event (GtkWidget* _sender,
                                                                                  GdkEventButton* event,
                                                                                  gpointer self);
static void _camera_widgets_header_bar___lambda14_ (Block6Data* _data6_);
static void __camera_widgets_header_bar___lambda14__gtk_range_value_changed (GtkRange* _sender,
                                                                      gpointer self);
static void _camera_widgets_header_bar___lambda15_ (Block6Data* _data6_);
static void __camera_widgets_header_bar___lambda15__gtk_range_value_changed (GtkRange* _sender,
                                                                      gpointer self);
static void _camera_widgets_header_bar___lambda16_ (CameraWidgetsHeaderBar* self,
                                             const gchar* key);
GType camera_utils_action_type_get_type (void) G_GNUC_CONST;
static void __camera_widgets_header_bar___lambda16__g_settings_changed (GSettings* _sender,
                                                                 const gchar* key,
                                                                 gpointer self);
static void _camera_widgets_header_bar___lambda17_ (CameraWidgetsHeaderBar* self);
#define CAMERA_MAIN_WINDOW_ACTION_RECORD "record"
static void __camera_widgets_header_bar___lambda17__g_object_notify (GObject* _sender,
                                                              GParamSpec* pspec,
                                                              gpointer self);
static void _camera_widgets_header_bar___lambda18_ (CameraWidgetsHeaderBar* self);
static void __camera_widgets_header_bar___lambda18__g_object_notify (GObject* _sender,
                                                              GParamSpec* pspec,
                                                              gpointer self);
static void camera_widgets_header_bar_finalize (GObject * obj);
static GType camera_widgets_header_bar_get_type_once (void);
static void _vala_camera_widgets_header_bar_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec);
static void _vala_camera_widgets_header_bar_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec);

static inline gpointer
camera_widgets_header_bar_get_instance_private (CameraWidgetsHeaderBar* self)
{
	return G_STRUCT_MEMBER_P (self, CameraWidgetsHeaderBar_private_offset);
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
	g_atomic_int_inc (&_data3_->_ref_count_);
	return _data3_;
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
		CameraWidgetsHeaderBar* self;
		self = _data3_->self;
		_g_object_unref0 (self);
		g_slice_free (Block3Data, _data3_);
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
__lambda10_ (Block3Data* _data3_)
{
	CameraWidgetsHeaderBar* self;
	self = _data3_->self;
	g_signal_emit (self, camera_widgets_header_bar_signals[CAMERA_WIDGETS_HEADER_BAR_REQUEST_CAMERA_CHANGE_SIGNAL], 0, _data3_->i);
}

static void
___lambda10__gtk_menu_item_activate (GtkMenuItem* _sender,
                                     gpointer self)
{
	__lambda10_ (self);
}

void
camera_widgets_header_bar_add_camera_option (CameraWidgetsHeaderBar* self,
                                             GstDevice* camera)
{
	Block3Data* _data3_;
	GtkRadioMenuItem* menuitem = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GtkRadioMenuItem* _tmp2_;
	GtkRadioMenuItem* _tmp3_;
	GtkMenu* _tmp4_;
	GtkRadioMenuItem* _tmp5_;
	GtkMenu* _tmp6_;
	GList* _tmp7_;
	GList* _tmp8_;
	gint _tmp9_;
	GtkRadioMenuItem* _tmp19_;
	GtkRadioMenuItem* _tmp20_;
	GtkRadioMenuItem* _tmp21_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (camera != NULL);
	_data3_ = g_slice_new0 (Block3Data);
	_data3_->_ref_count_ = 1;
	_data3_->self = g_object_ref (self);
	_tmp0_ = gst_device_get_display_name (camera);
	_tmp1_ = _tmp0_;
	_tmp2_ = (GtkRadioMenuItem*) gtk_radio_menu_item_new_with_label (NULL, _tmp1_);
	g_object_ref_sink (_tmp2_);
	_tmp3_ = _tmp2_;
	_g_free0 (_tmp1_);
	menuitem = _tmp3_;
	_tmp4_ = self->priv->camera_options;
	_tmp5_ = menuitem;
	gtk_menu_shell_append ((GtkMenuShell*) _tmp4_, (GtkMenuItem*) _tmp5_);
	_tmp6_ = self->priv->camera_options;
	_tmp7_ = gtk_container_get_children ((GtkContainer*) _tmp6_);
	_tmp8_ = _tmp7_;
	_tmp9_ = ((gint) g_list_length (_tmp8_)) - 1;
	(_tmp8_ == NULL) ? NULL : (_tmp8_ = (g_list_free (_tmp8_), NULL));
	_data3_->i = _tmp9_;
	if (_data3_->i > 0) {
		GtkRadioMenuItem* el = NULL;
		GtkMenu* _tmp10_;
		GList* _tmp11_;
		GList* _tmp12_;
		gconstpointer _tmp13_;
		GtkWidget* _tmp14_;
		GtkRadioMenuItem* _tmp15_;
		GtkRadioMenuItem* _tmp16_;
		GtkRadioMenuItem* _tmp17_;
		GtkRadioMenuItem* _tmp18_;
		_tmp10_ = self->priv->camera_options;
		_tmp11_ = gtk_container_get_children ((GtkContainer*) _tmp10_);
		_tmp12_ = _tmp11_;
		_tmp13_ = g_list_nth_data (_tmp12_, (guint) 0);
		_tmp14_ = (GtkWidget*) _tmp13_;
		_tmp15_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp14_, gtk_radio_menu_item_get_type ()) ? ((GtkRadioMenuItem*) _tmp14_) : NULL);
		_tmp16_ = _tmp15_;
		(_tmp12_ == NULL) ? NULL : (_tmp12_ = (g_list_free (_tmp12_), NULL));
		el = _tmp16_;
		_tmp17_ = menuitem;
		_tmp18_ = el;
		gtk_radio_menu_item_join_group (_tmp17_, _tmp18_);
		_g_object_unref0 (el);
	}
	_tmp19_ = menuitem;
	gtk_check_menu_item_set_active ((GtkCheckMenuItem*) _tmp19_, TRUE);
	_tmp20_ = menuitem;
	g_signal_connect_data ((GtkMenuItem*) _tmp20_, "activate", (GCallback) ___lambda10__gtk_menu_item_activate, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
	_tmp21_ = menuitem;
	gtk_widget_show ((GtkWidget*) _tmp21_);
	camera_widgets_header_bar_update_take_button (self);
	_g_object_unref0 (menuitem);
	block3_data_unref (_data3_);
	_data3_ = NULL;
}

void
camera_widgets_header_bar_remove_camera_option (CameraWidgetsHeaderBar* self,
                                                GstDevice* camera)
{
	GtkWidget* to_remove = NULL;
	GtkMenu* _tmp0_;
	GList* _tmp1_;
	GtkWidget* _tmp12_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (camera != NULL);
	to_remove = NULL;
	_tmp0_ = self->priv->camera_options;
	_tmp1_ = gtk_container_get_children ((GtkContainer*) _tmp0_);
	{
		GList* menuitem_collection = NULL;
		GList* menuitem_it = NULL;
		menuitem_collection = _tmp1_;
		for (menuitem_it = menuitem_collection; menuitem_it != NULL; menuitem_it = menuitem_it->next) {
			GtkWidget* menuitem = NULL;
			menuitem = (GtkWidget*) menuitem_it->data;
			{
				gchar* name = NULL;
				GtkWidget* _tmp2_;
				const gchar* _tmp3_;
				const gchar* _tmp4_;
				gchar* _tmp5_;
				const gchar* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
				gboolean _tmp9_;
				_tmp2_ = menuitem;
				_tmp3_ = gtk_menu_item_get_label (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_menu_item_get_type (), GtkMenuItem));
				_tmp4_ = _tmp3_;
				_tmp5_ = g_strdup (_tmp4_);
				name = _tmp5_;
				_tmp6_ = name;
				_tmp7_ = gst_device_get_display_name (camera);
				_tmp8_ = _tmp7_;
				_tmp9_ = g_strcmp0 (_tmp6_, _tmp8_) == 0;
				_g_free0 (_tmp8_);
				if (_tmp9_) {
					GtkWidget* _tmp10_;
					GtkWidget* _tmp11_;
					_tmp10_ = menuitem;
					_tmp11_ = _g_object_ref0 (_tmp10_);
					_g_object_unref0 (to_remove);
					to_remove = _tmp11_;
					_g_free0 (name);
					break;
				}
				_g_free0 (name);
			}
		}
		(menuitem_collection == NULL) ? NULL : (menuitem_collection = (g_list_free (menuitem_collection), NULL));
	}
	_tmp12_ = to_remove;
	if (_tmp12_ != NULL) {
		GtkMenu* _tmp13_;
		GtkWidget* _tmp14_;
		_tmp13_ = self->priv->camera_options;
		_tmp14_ = to_remove;
		gtk_container_remove ((GtkContainer*) _tmp13_, _tmp14_);
	}
	camera_widgets_header_bar_update_take_button (self);
	_g_object_unref0 (to_remove);
}

static void
camera_widgets_header_bar_update_take_button (CameraWidgetsHeaderBar* self)
{
	GtkStyleContext* take_button_style_context = NULL;
	GtkButton* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkMenu* _tmp2_;
	GList* _tmp3_;
	GList* _tmp4_;
	gboolean _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->take_button;
	_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) _tmp0_);
	take_button_style_context = _tmp1_;
	_tmp2_ = self->priv->camera_options;
	_tmp3_ = gtk_container_get_children ((GtkContainer*) _tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_list_length (_tmp4_) > ((guint) 1);
	(_tmp4_ == NULL) ? NULL : (_tmp4_ = (g_list_free (_tmp4_), NULL));
	if (_tmp5_) {
		GtkRevealer* _tmp6_;
		GtkStyleContext* _tmp7_;
		_tmp6_ = self->priv->camera_menu_revealer;
		gtk_revealer_set_reveal_child (_tmp6_, TRUE);
		_tmp7_ = take_button_style_context;
		gtk_style_context_add_class (_tmp7_, "multiple");
	} else {
		GtkRevealer* _tmp8_;
		GtkStyleContext* _tmp9_;
		_tmp8_ = self->priv->camera_menu_revealer;
		gtk_revealer_set_reveal_child (_tmp8_, FALSE);
		_tmp9_ = take_button_style_context;
		gtk_style_context_remove_class (_tmp9_, "multiple");
	}
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
	g_atomic_int_inc (&_data4_->_ref_count_);
	return _data4_;
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
		CameraWidgetsHeaderBar* self;
		self = _data4_->self;
		_g_object_unref0 (self);
		g_slice_free (Block4Data, _data4_);
	}
}

static gboolean
___lambda11_ (Block4Data* _data4_)
{
	CameraWidgetsHeaderBar* self;
	gboolean result = FALSE;
	self = _data4_->self;
	camera_widgets_header_bar_start_timeout (self, _data4_->time - 1);
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
____lambda11__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda11_ (self);
	return result;
}

void
camera_widgets_header_bar_start_timeout (CameraWidgetsHeaderBar* self,
                                         gint time)
{
	Block4Data* _data4_;
	gboolean timeout_reached = FALSE;
	GraniteModeSwitch* _tmp0_;
	GtkImage* _tmp1_;
	CameraWidgetsTimerButton* _tmp2_;
	GtkRevealer* _tmp3_;
	g_return_if_fail (self != NULL);
	_data4_ = g_slice_new0 (Block4Data);
	_data4_->_ref_count_ = 1;
	_data4_->self = g_object_ref (self);
	_data4_->time = time;
	timeout_reached = _data4_->time == 0;
	_tmp0_ = self->priv->mode_switch;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, timeout_reached);
	_tmp1_ = self->priv->take_image;
	gtk_widget_set_visible ((GtkWidget*) _tmp1_, timeout_reached);
	_tmp2_ = self->priv->timer_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp2_, timeout_reached);
	_tmp3_ = self->priv->video_timer_revealer;
	gtk_revealer_set_reveal_child (_tmp3_, !timeout_reached);
	if (!timeout_reached) {
		GtkLabel* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp4_ = self->priv->take_timer;
		_tmp5_ = g_strdup_printf ("%i", _data4_->time);
		_tmp6_ = _tmp5_;
		gtk_label_set_label (_tmp4_, _tmp6_);
		_g_free0 (_tmp6_);
		g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 1, ____lambda11__gsource_func, block4_data_ref (_data4_), block4_data_unref);
	}
	block4_data_unref (_data4_);
	_data4_ = NULL;
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
	g_atomic_int_inc (&_data5_->_ref_count_);
	return _data5_;
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
		CameraWidgetsHeaderBar* self;
		self = _data5_->self;
		_g_object_unref0 (self);
		g_slice_free (Block5Data, _data5_);
	}
}

static gboolean
__lambda12_ (Block5Data* _data5_)
{
	CameraWidgetsHeaderBar* self;
	gint _tmp0_;
	GtkLabel* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean result = FALSE;
	self = _data5_->self;
	_tmp0_ = _data5_->seconds;
	_data5_->seconds = _tmp0_ + 1;
	_tmp1_ = self->priv->take_timer;
	_tmp2_ = granite_date_time_seconds_to_time (_data5_->seconds);
	_tmp3_ = _tmp2_;
	gtk_label_set_label (_tmp1_, _tmp3_);
	_g_free0 (_tmp3_);
	result = G_SOURCE_CONTINUE;
	return result;
}

static gboolean
___lambda12__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda12_ (self);
	return result;
}

void
camera_widgets_header_bar_start_recording_time (CameraWidgetsHeaderBar* self)
{
	Block5Data* _data5_;
	GtkLabel* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	g_return_if_fail (self != NULL);
	_data5_ = g_slice_new0 (Block5Data);
	_data5_->_ref_count_ = 1;
	_data5_->self = g_object_ref (self);
	camera_widgets_header_bar_set_recording (self, TRUE);
	_data5_->seconds = 0;
	_tmp0_ = self->priv->take_timer;
	_tmp1_ = granite_date_time_seconds_to_time (_data5_->seconds);
	_tmp2_ = _tmp1_;
	gtk_label_set_label (_tmp0_, _tmp2_);
	_g_free0 (_tmp2_);
	self->priv->recording_timeout = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 1, ___lambda12__gsource_func, block5_data_ref (_data5_), block5_data_unref);
	block5_data_unref (_data5_);
	_data5_ = NULL;
}

void
camera_widgets_header_bar_stop_recording_time (CameraWidgetsHeaderBar* self)
{
	g_return_if_fail (self != NULL);
	camera_widgets_header_bar_set_recording (self, FALSE);
	g_source_remove (self->priv->recording_timeout);
	self->priv->recording_timeout = 0U;
}

CameraWidgetsHeaderBar*
camera_widgets_header_bar_construct (GType object_type)
{
	CameraWidgetsHeaderBar * self = NULL;
	self = (CameraWidgetsHeaderBar*) g_object_new (object_type, NULL);
	return self;
}

CameraWidgetsHeaderBar*
camera_widgets_header_bar_new (void)
{
	return camera_widgets_header_bar_construct (CAMERA_WIDGETS_TYPE_HEADER_BAR);
}

gboolean
camera_widgets_header_bar_get_recording (CameraWidgetsHeaderBar* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_recording;
	return result;
}

void
camera_widgets_header_bar_set_recording (CameraWidgetsHeaderBar* self,
                                         gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = camera_widgets_header_bar_get_recording (self);
	if (old_value != value) {
		self->priv->_recording = value;
		g_object_notify_by_pspec ((GObject *) self, camera_widgets_header_bar_properties[CAMERA_WIDGETS_HEADER_BAR_RECORDING_PROPERTY]);
	}
}

gboolean
camera_widgets_header_bar_get_horizontal_flip (CameraWidgetsHeaderBar* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_horizontal_flip;
	return result;
}

void
camera_widgets_header_bar_set_horizontal_flip (CameraWidgetsHeaderBar* self,
                                               gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = camera_widgets_header_bar_get_horizontal_flip (self);
	if (old_value != value) {
		self->priv->_horizontal_flip = value;
		g_object_notify_by_pspec ((GObject *) self, camera_widgets_header_bar_properties[CAMERA_WIDGETS_HEADER_BAR_HORIZONTAL_FLIP_PROPERTY]);
	}
}

gint
camera_widgets_header_bar_get_timer_delay (CameraWidgetsHeaderBar* self)
{
	gint result;
	CameraWidgetsTimerButton* _tmp0_;
	CameraWidgetsTimerButtonDelay _tmp1_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->timer_button;
	_tmp1_ = _tmp0_->delay;
	result = (gint) _tmp1_;
	return result;
}

static void
g_cclosure_user_marshal_VOID__DOUBLE_DOUBLE (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__DOUBLE_DOUBLE) (gpointer data1, gdouble arg_1, gdouble arg_2, gpointer data2);
	register GMarshalFunc_VOID__DOUBLE_DOUBLE callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__DOUBLE_DOUBLE) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_double (param_values + 1), g_value_get_double (param_values + 2), data2);
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
	g_atomic_int_inc (&_data6_->_ref_count_);
	return _data6_;
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
		CameraWidgetsHeaderBar* self;
		self = _data6_->self;
		_g_object_unref0 (_data6_->contrast_scale);
		_g_object_unref0 (_data6_->brightness_scale);
		_g_object_unref0 (_data6_->mirror_switch);
		_g_object_unref0 (self);
		g_slice_free (Block6Data, _data6_);
	}
}

static gboolean
_camera_widgets_header_bar___lambda13_ (Block6Data* _data6_)
{
	CameraWidgetsHeaderBar* self;
	GtkSwitch* _tmp0_;
	gboolean result = FALSE;
	self = _data6_->self;
	_tmp0_ = _data6_->mirror_switch;
	g_signal_emit_by_name (_tmp0_, "activate");
	result = GDK_EVENT_STOP;
	return result;
}

static gboolean
__camera_widgets_header_bar___lambda13__gtk_widget_button_release_event (GtkWidget* _sender,
                                                                         GdkEventButton* event,
                                                                         gpointer self)
{
	gboolean result;
	result = _camera_widgets_header_bar___lambda13_ (self);
	return result;
}

static void
_camera_widgets_header_bar___lambda14_ (Block6Data* _data6_)
{
	CameraWidgetsHeaderBar* self;
	GtkScale* _tmp0_;
	GtkScale* _tmp1_;
	self = _data6_->self;
	_tmp0_ = _data6_->brightness_scale;
	_tmp1_ = _data6_->contrast_scale;
	g_signal_emit (self, camera_widgets_header_bar_signals[CAMERA_WIDGETS_HEADER_BAR_REQUEST_CHANGE_BALANCE_SIGNAL], 0, gtk_range_get_value ((GtkRange*) _tmp0_), gtk_range_get_value ((GtkRange*) _tmp1_));
}

static void
__camera_widgets_header_bar___lambda14__gtk_range_value_changed (GtkRange* _sender,
                                                                 gpointer self)
{
	_camera_widgets_header_bar___lambda14_ (self);
}

static void
_camera_widgets_header_bar___lambda15_ (Block6Data* _data6_)
{
	CameraWidgetsHeaderBar* self;
	GtkScale* _tmp0_;
	GtkScale* _tmp1_;
	self = _data6_->self;
	_tmp0_ = _data6_->brightness_scale;
	_tmp1_ = _data6_->contrast_scale;
	g_signal_emit (self, camera_widgets_header_bar_signals[CAMERA_WIDGETS_HEADER_BAR_REQUEST_CHANGE_BALANCE_SIGNAL], 0, gtk_range_get_value ((GtkRange*) _tmp0_), gtk_range_get_value ((GtkRange*) _tmp1_));
}

static void
__camera_widgets_header_bar___lambda15__gtk_range_value_changed (GtkRange* _sender,
                                                                 gpointer self)
{
	_camera_widgets_header_bar___lambda15_ (self);
}

static void
_camera_widgets_header_bar___lambda16_ (CameraWidgetsHeaderBar* self,
                                        const gchar* key)
{
	GraniteModeSwitch* _tmp0_;
	GSettings* _tmp1_;
	g_return_if_fail (key != NULL);
	_tmp0_ = self->priv->mode_switch;
	_tmp1_ = camera_application_settings;
	granite_mode_switch_set_active (_tmp0_, g_settings_get_enum (_tmp1_, "mode") == ((gint) CAMERA_UTILS_ACTION_TYPE_VIDEO));
}

static void
__camera_widgets_header_bar___lambda16__g_settings_changed (GSettings* _sender,
                                                            const gchar* key,
                                                            gpointer self)
{
	_camera_widgets_header_bar___lambda16_ ((CameraWidgetsHeaderBar*) self, key);
}

static void
_camera_widgets_header_bar___lambda17_ (CameraWidgetsHeaderBar* self)
{
	GraniteModeSwitch* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	_tmp0_ = self->priv->mode_switch;
	_tmp1_ = granite_mode_switch_get_active (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		GSettings* _tmp3_;
		GtkButton* _tmp4_;
		GtkImage* _tmp5_;
		CameraWidgetsTimerButton* _tmp6_;
		_tmp3_ = camera_application_settings;
		g_settings_set_enum (_tmp3_, "mode", (gint) CAMERA_UTILS_ACTION_TYPE_VIDEO);
		_tmp4_ = self->priv->take_button;
		gtk_actionable_set_action_name ((GtkActionable*) _tmp4_, CAMERA_MAIN_WINDOW_ACTION_PREFIX CAMERA_MAIN_WINDOW_ACTION_RECORD);
		_tmp5_ = self->priv->take_image;
		g_object_set (_tmp5_, "icon-name", CAMERA_WIDGETS_HEADER_BAR_VIDEO_ICON_SYMBOLIC, NULL);
		_tmp6_ = self->priv->timer_button;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp6_, FALSE);
	} else {
		GSettings* _tmp7_;
		GtkButton* _tmp8_;
		GtkImage* _tmp9_;
		CameraWidgetsTimerButton* _tmp10_;
		_tmp7_ = camera_application_settings;
		g_settings_set_enum (_tmp7_, "mode", (gint) CAMERA_UTILS_ACTION_TYPE_PHOTO);
		_tmp8_ = self->priv->take_button;
		gtk_actionable_set_action_name ((GtkActionable*) _tmp8_, CAMERA_MAIN_WINDOW_ACTION_PREFIX CAMERA_MAIN_WINDOW_ACTION_TAKE_PHOTO);
		_tmp9_ = self->priv->take_image;
		g_object_set (_tmp9_, "icon-name", CAMERA_WIDGETS_HEADER_BAR_PHOTO_ICON_SYMBOLIC, NULL);
		_tmp10_ = self->priv->timer_button;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp10_, TRUE);
	}
}

static void
__camera_widgets_header_bar___lambda17__g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self)
{
	_camera_widgets_header_bar___lambda17_ ((CameraWidgetsHeaderBar*) self);
}

static void
_camera_widgets_header_bar___lambda18_ (CameraWidgetsHeaderBar* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	CameraWidgetsTimerButton* _tmp5_;
	GraniteModeSwitch* _tmp6_;
	gboolean _tmp7_;
	GtkRevealer* _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	_tmp1_ = self->priv->_recording;
	if (!_tmp1_) {
		GraniteModeSwitch* _tmp2_;
		gboolean _tmp3_;
		gboolean _tmp4_;
		_tmp2_ = self->priv->mode_switch;
		_tmp3_ = granite_mode_switch_get_active (_tmp2_);
		_tmp4_ = _tmp3_;
		_tmp0_ = !_tmp4_;
	} else {
		_tmp0_ = FALSE;
	}
	_tmp5_ = self->priv->timer_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp5_, _tmp0_);
	_tmp6_ = self->priv->mode_switch;
	_tmp7_ = self->priv->_recording;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp6_, !_tmp7_);
	_tmp8_ = self->priv->video_timer_revealer;
	_tmp9_ = self->priv->_recording;
	gtk_revealer_set_reveal_child (_tmp8_, _tmp9_);
	_tmp10_ = self->priv->_recording;
	if (_tmp10_) {
		GtkImage* _tmp11_;
		_tmp11_ = self->priv->take_image;
		g_object_set (_tmp11_, "icon-name", CAMERA_WIDGETS_HEADER_BAR_STOP_ICON_SYMBOLIC, NULL);
	} else {
		GtkImage* _tmp12_;
		_tmp12_ = self->priv->take_image;
		g_object_set (_tmp12_, "icon-name", CAMERA_WIDGETS_HEADER_BAR_VIDEO_ICON_SYMBOLIC, NULL);
	}
}

static void
__camera_widgets_header_bar___lambda18__g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self)
{
	_camera_widgets_header_bar___lambda18_ ((CameraWidgetsHeaderBar*) self);
}

static GObject *
camera_widgets_header_bar_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	CameraWidgetsHeaderBar * self;
	Block6Data* _data6_;
	CameraWidgetsTimerButton* _tmp0_;
	CameraWidgetsTimerButton* _tmp1_;
	GtkImage* _tmp2_;
	GtkImage* _tmp3_;
	GtkImage* _tmp4_;
	GtkImage* _tmp5_;
	GtkImage* _tmp6_;
	GtkLabel* _tmp7_;
	GtkRevealer* _tmp8_;
	GtkRevealer* _tmp9_;
	GtkRevealer* _tmp10_;
	GtkLabel* _tmp11_;
	GtkGrid* take_grid = NULL;
	GtkGrid* _tmp12_;
	GtkGrid* _tmp13_;
	GtkGrid* _tmp14_;
	GtkImage* _tmp15_;
	GtkGrid* _tmp16_;
	GtkRevealer* _tmp17_;
	GtkButton* _tmp18_;
	GtkButton* _tmp19_;
	GtkButton* _tmp20_;
	GtkButton* _tmp21_;
	GtkGrid* _tmp22_;
	GtkCssProvider* take_button_style_provider = NULL;
	GtkCssProvider* _tmp23_;
	GtkStyleContext* take_button_style_context = NULL;
	GtkButton* _tmp27_;
	GtkStyleContext* _tmp28_;
	GtkStyleContext* _tmp29_;
	GtkCssProvider* _tmp30_;
	GtkStyleContext* _tmp31_;
	GtkStyleContext* _tmp32_;
	GraniteModeSwitch* _tmp33_;
	GraniteModeSwitch* _tmp34_;
	GtkLabel* mirror_label = NULL;
	GtkLabel* _tmp35_ = NULL;
	GtkSwitch* _tmp36_;
	GtkSwitch* _tmp37_;
	GtkGrid* mirror_grid = NULL;
	GtkGrid* _tmp38_;
	GtkGrid* _tmp39_;
	GtkLabel* _tmp40_;
	GtkGrid* _tmp41_;
	GtkSwitch* _tmp42_;
	GtkModelButton* mirror_menuitem = NULL;
	GtkModelButton* _tmp43_;
	GtkModelButton* _tmp44_;
	GtkWidget* _tmp45_;
	GtkModelButton* _tmp46_;
	GtkGrid* _tmp47_;
	GtkModelButton* _tmp48_;
	GtkImage* brightness_image = NULL;
	GtkImage* _tmp49_;
	GtkLabel* brightness_label = NULL;
	GtkLabel* _tmp50_ = NULL;
	GtkImage* contrast_image = NULL;
	GtkImage* _tmp51_;
	GtkLabel* constrast_label = NULL;
	GtkLabel* _tmp52_ = NULL;
	GtkScale* _tmp53_ = NULL;
	GtkScale* _tmp54_;
	GtkScale* _tmp55_;
	GtkScale* _tmp56_ = NULL;
	GtkScale* _tmp57_;
	GtkScale* _tmp58_;
	GtkScale* _tmp59_;
	GtkScale* _tmp60_;
	GtkGrid* image_settings = NULL;
	GtkGrid* _tmp61_ = NULL;
	GtkGrid* _tmp62_;
	GtkImage* _tmp63_;
	GtkGrid* _tmp64_;
	GtkLabel* _tmp65_;
	GtkGrid* _tmp66_;
	GtkScale* _tmp67_;
	GtkGrid* _tmp68_;
	GtkImage* _tmp69_;
	GtkGrid* _tmp70_;
	GtkLabel* _tmp71_;
	GtkGrid* _tmp72_;
	GtkScale* _tmp73_;
	GtkGrid* menu_popover_grid = NULL;
	GtkGrid* _tmp74_ = NULL;
	GtkGrid* _tmp75_;
	GtkGrid* _tmp76_;
	GtkGrid* _tmp77_;
	GtkModelButton* _tmp78_;
	GtkGrid* _tmp79_;
	GtkPopover* popover = NULL;
	GtkPopover* _tmp80_;
	GtkPopover* _tmp81_;
	GtkGrid* _tmp82_;
	GtkMenuButton* menu_button = NULL;
	GtkImage* _tmp83_;
	GtkPopover* _tmp84_;
	GtkPopover* _tmp85_;
	gchar* _tmp86_;
	GtkMenuButton* _tmp87_ = NULL;
	GtkMenuButton* _tmp88_;
	GtkMenu* _tmp89_;
	GtkMenu* _tmp90_;
	GtkMenu* _tmp91_;
	GtkMenuButton* _tmp92_ = NULL;
	GtkStyleContext* camera_menu_button_style_context = NULL;
	GtkMenuButton* _tmp93_;
	GtkStyleContext* _tmp94_;
	GtkStyleContext* _tmp95_;
	GtkCssProvider* _tmp96_;
	GtkStyleContext* _tmp97_;
	GtkStyleContext* _tmp98_;
	GtkRevealer* _tmp99_ = NULL;
	GtkRevealer* _tmp100_;
	GtkMenuButton* _tmp101_;
	GtkGrid* linked_box = NULL;
	GtkGrid* _tmp102_;
	GtkGrid* _tmp103_;
	GtkButton* _tmp104_;
	GtkGrid* _tmp105_;
	GtkRevealer* _tmp106_;
	GtkStyleContext* _tmp107_;
	CameraWidgetsTimerButton* _tmp108_;
	GtkGrid* _tmp109_;
	GtkMenuButton* _tmp110_;
	GtkSeparator* _tmp111_;
	GtkSeparator* _tmp112_;
	GraniteModeSwitch* _tmp113_;
	GSettings* _tmp114_;
	GraniteModeSwitch* _tmp115_;
	GraniteModeSwitch* _tmp116_;
	GSettings* _tmp117_;
	GError* _inner_error0_ = NULL;
	parent_class = G_OBJECT_CLASS (camera_widgets_header_bar_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CAMERA_WIDGETS_TYPE_HEADER_BAR, CameraWidgetsHeaderBar);
	_data6_ = g_slice_new0 (Block6Data);
	_data6_->_ref_count_ = 1;
	_data6_->self = g_object_ref (self);
	_tmp0_ = camera_widgets_timer_button_new ();
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->timer_button);
	self->priv->timer_button = _tmp0_;
	_tmp1_ = self->priv->timer_button;
	_tmp2_ = (GtkImage*) gtk_image_new_from_icon_name ("timer-symbolic", (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
	g_object_ref_sink (_tmp2_);
	_tmp3_ = _tmp2_;
	gtk_button_set_image ((GtkButton*) _tmp1_, (GtkWidget*) _tmp3_);
	_g_object_unref0 (_tmp3_);
	_tmp4_ = (GtkImage*) gtk_image_new ();
	g_object_ref_sink (_tmp4_);
	_g_object_unref0 (self->priv->take_image);
	self->priv->take_image = _tmp4_;
	_tmp5_ = self->priv->take_image;
	g_object_set (_tmp5_, "icon-name", CAMERA_WIDGETS_HEADER_BAR_PHOTO_ICON_SYMBOLIC, NULL);
	_tmp6_ = self->priv->take_image;
	g_object_set (_tmp6_, "icon-size", (gint) GTK_ICON_SIZE_BUTTON, NULL);
	_tmp7_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp7_);
	_g_object_unref0 (self->priv->take_timer);
	self->priv->take_timer = _tmp7_;
	_tmp8_ = (GtkRevealer*) gtk_revealer_new ();
	g_object_ref_sink (_tmp8_);
	_g_object_unref0 (self->priv->video_timer_revealer);
	self->priv->video_timer_revealer = _tmp8_;
	_tmp9_ = self->priv->video_timer_revealer;
	gtk_revealer_set_transition_type (_tmp9_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_RIGHT);
	_tmp10_ = self->priv->video_timer_revealer;
	_tmp11_ = self->priv->take_timer;
	gtk_container_add ((GtkContainer*) _tmp10_, (GtkWidget*) _tmp11_);
	_tmp12_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp12_);
	take_grid = _tmp12_;
	_tmp13_ = take_grid;
	gtk_widget_set_halign ((GtkWidget*) _tmp13_, GTK_ALIGN_CENTER);
	_tmp14_ = take_grid;
	_tmp15_ = self->priv->take_image;
	gtk_container_add ((GtkContainer*) _tmp14_, (GtkWidget*) _tmp15_);
	_tmp16_ = take_grid;
	_tmp17_ = self->priv->video_timer_revealer;
	gtk_container_add ((GtkContainer*) _tmp16_, (GtkWidget*) _tmp17_);
	_tmp18_ = (GtkButton*) gtk_button_new ();
	g_object_ref_sink (_tmp18_);
	_g_object_unref0 (self->priv->take_button);
	self->priv->take_button = _tmp18_;
	_tmp19_ = self->priv->take_button;
	gtk_actionable_set_action_name ((GtkActionable*) _tmp19_, CAMERA_MAIN_WINDOW_ACTION_PREFIX CAMERA_MAIN_WINDOW_ACTION_TAKE_PHOTO);
	_tmp20_ = self->priv->take_button;
	g_object_set ((GtkWidget*) _tmp20_, "width-request", 54, NULL);
	_tmp21_ = self->priv->take_button;
	_tmp22_ = take_grid;
	gtk_container_add ((GtkContainer*) _tmp21_, (GtkWidget*) _tmp22_);
	_tmp23_ = gtk_css_provider_new ();
	take_button_style_provider = _tmp23_;
	{
		GtkCssProvider* _tmp24_;
		_tmp24_ = take_button_style_provider;
		gtk_css_provider_load_from_data (_tmp24_, CAMERA_WIDGETS_HEADER_BAR_TAKE_BUTTON_STYLESHEET, (gssize) -1, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp25_;
		const gchar* _tmp26_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp25_ = e;
		_tmp26_ = _tmp25_->message;
		g_warning ("HeaderBar.vala:101: Styling take button failed: %s", _tmp26_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (take_button_style_provider);
		_g_object_unref0 (take_grid);
		block6_data_unref (_data6_);
		_data6_ = NULL;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
	}
	_tmp27_ = self->priv->take_button;
	_tmp28_ = gtk_widget_get_style_context ((GtkWidget*) _tmp27_);
	take_button_style_context = _tmp28_;
	_tmp29_ = take_button_style_context;
	_tmp30_ = take_button_style_provider;
	gtk_style_context_add_provider (_tmp29_, (GtkStyleProvider*) _tmp30_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
	_tmp31_ = take_button_style_context;
	gtk_style_context_add_class (_tmp31_, "take-button");
	_tmp32_ = take_button_style_context;
	gtk_style_context_add_class (_tmp32_, GTK_STYLE_CLASS_DESTRUCTIVE_ACTION);
	_tmp33_ = granite_mode_switch_new_from_icon_name (CAMERA_WIDGETS_HEADER_BAR_PHOTO_ICON_SYMBOLIC, CAMERA_WIDGETS_HEADER_BAR_VIDEO_ICON_SYMBOLIC);
	g_object_ref_sink (_tmp33_);
	_g_object_unref0 (self->priv->mode_switch);
	self->priv->mode_switch = _tmp33_;
	_tmp34_ = self->priv->mode_switch;
	gtk_widget_set_valign ((GtkWidget*) _tmp34_, GTK_ALIGN_CENTER);
	_tmp35_ = (GtkLabel*) gtk_label_new (_ ("Mirror"));
	gtk_widget_set_hexpand ((GtkWidget*) _tmp35_, TRUE);
	gtk_widget_set_halign ((GtkWidget*) _tmp35_, GTK_ALIGN_START);
	g_object_ref_sink (_tmp35_);
	mirror_label = _tmp35_;
	_tmp36_ = (GtkSwitch*) gtk_switch_new ();
	g_object_ref_sink (_tmp36_);
	_data6_->mirror_switch = _tmp36_;
	_tmp37_ = _data6_->mirror_switch;
	g_object_bind_property_with_closures ((GObject*) _tmp37_, "active", (GObject*) self, "horizontal-flip", G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp38_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp38_);
	mirror_grid = _tmp38_;
	_tmp39_ = mirror_grid;
	_tmp40_ = mirror_label;
	gtk_container_add ((GtkContainer*) _tmp39_, (GtkWidget*) _tmp40_);
	_tmp41_ = mirror_grid;
	_tmp42_ = _data6_->mirror_switch;
	gtk_container_add ((GtkContainer*) _tmp41_, (GtkWidget*) _tmp42_);
	_tmp43_ = (GtkModelButton*) gtk_model_button_new ();
	g_object_ref_sink (_tmp43_);
	mirror_menuitem = _tmp43_;
	_tmp44_ = mirror_menuitem;
	_tmp45_ = gtk_bin_get_child ((GtkBin*) _tmp44_);
	gtk_widget_destroy (_tmp45_);
	_tmp46_ = mirror_menuitem;
	_tmp47_ = mirror_grid;
	gtk_container_add ((GtkContainer*) _tmp46_, (GtkWidget*) _tmp47_);
	_tmp48_ = mirror_menuitem;
	g_signal_connect_data ((GtkWidget*) _tmp48_, "button-release-event", (GCallback) __camera_widgets_header_bar___lambda13__gtk_widget_button_release_event, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
	_tmp49_ = (GtkImage*) gtk_image_new_from_icon_name ("display-brightness-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp49_);
	brightness_image = _tmp49_;
	_tmp50_ = (GtkLabel*) gtk_label_new (_ ("Brightness"));
	gtk_widget_set_hexpand ((GtkWidget*) _tmp50_, TRUE);
	gtk_label_set_xalign (_tmp50_, (gfloat) 0);
	g_object_ref_sink (_tmp50_);
	brightness_label = _tmp50_;
	_tmp51_ = (GtkImage*) gtk_image_new_from_icon_name ("color-contrast-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp51_);
	contrast_image = _tmp51_;
	_tmp52_ = (GtkLabel*) gtk_label_new (_ ("Contrast"));
	gtk_widget_set_hexpand ((GtkWidget*) _tmp52_, TRUE);
	gtk_label_set_xalign (_tmp52_, (gfloat) 0);
	g_object_ref_sink (_tmp52_);
	constrast_label = _tmp52_;
	_tmp53_ = (GtkScale*) gtk_scale_new_with_range (GTK_ORIENTATION_HORIZONTAL, (gdouble) -1, (gdouble) 1, 0.1);
	gtk_scale_set_draw_value (_tmp53_, FALSE);
	gtk_widget_set_hexpand ((GtkWidget*) _tmp53_, TRUE);
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp53_, 6);
	g_object_ref_sink (_tmp53_);
	_data6_->brightness_scale = _tmp53_;
	_tmp54_ = _data6_->brightness_scale;
	gtk_range_set_value ((GtkRange*) _tmp54_, (gdouble) 0);
	_tmp55_ = _data6_->brightness_scale;
	gtk_scale_add_mark (_tmp55_, (gdouble) 0, GTK_POS_BOTTOM, "");
	_tmp56_ = (GtkScale*) gtk_scale_new_with_range (GTK_ORIENTATION_HORIZONTAL, (gdouble) 0, (gdouble) 2, 0.1);
	gtk_scale_set_draw_value (_tmp56_, FALSE);
	gtk_widget_set_hexpand ((GtkWidget*) _tmp56_, FALSE);
	g_object_ref_sink (_tmp56_);
	_data6_->contrast_scale = _tmp56_;
	_tmp57_ = _data6_->contrast_scale;
	gtk_range_set_value ((GtkRange*) _tmp57_, (gdouble) 1);
	_tmp58_ = _data6_->contrast_scale;
	gtk_scale_add_mark (_tmp58_, (gdouble) 1, GTK_POS_BOTTOM, "");
	_tmp59_ = _data6_->brightness_scale;
	g_signal_connect_data ((GtkRange*) _tmp59_, "value-changed", (GCallback) __camera_widgets_header_bar___lambda14__gtk_range_value_changed, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
	_tmp60_ = _data6_->contrast_scale;
	g_signal_connect_data ((GtkRange*) _tmp60_, "value-changed", (GCallback) __camera_widgets_header_bar___lambda15__gtk_range_value_changed, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
	_tmp61_ = (GtkGrid*) gtk_grid_new ();
	gtk_grid_set_column_spacing (_tmp61_, 6);
	gtk_grid_set_row_spacing (_tmp61_, 3);
	g_object_set ((GtkWidget*) _tmp61_, "margin", 12, NULL);
	g_object_ref_sink (_tmp61_);
	image_settings = _tmp61_;
	_tmp62_ = image_settings;
	_tmp63_ = brightness_image;
	gtk_grid_attach (_tmp62_, (GtkWidget*) _tmp63_, 0, 0, 1, 1);
	_tmp64_ = image_settings;
	_tmp65_ = brightness_label;
	gtk_grid_attach (_tmp64_, (GtkWidget*) _tmp65_, 1, 0, 1, 1);
	_tmp66_ = image_settings;
	_tmp67_ = _data6_->brightness_scale;
	gtk_grid_attach (_tmp66_, (GtkWidget*) _tmp67_, 0, 1, 2, 1);
	_tmp68_ = image_settings;
	_tmp69_ = contrast_image;
	gtk_grid_attach (_tmp68_, (GtkWidget*) _tmp69_, 0, 2, 1, 1);
	_tmp70_ = image_settings;
	_tmp71_ = constrast_label;
	gtk_grid_attach (_tmp70_, (GtkWidget*) _tmp71_, 1, 2, 1, 1);
	_tmp72_ = image_settings;
	_tmp73_ = _data6_->contrast_scale;
	gtk_grid_attach (_tmp72_, (GtkWidget*) _tmp73_, 0, 3, 2, 1);
	_tmp74_ = (GtkGrid*) gtk_grid_new ();
	g_object_set ((GtkWidget*) _tmp74_, "width-request", 250, NULL);
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp74_, 3);
	g_object_ref_sink (_tmp74_);
	menu_popover_grid = _tmp74_;
	_tmp75_ = menu_popover_grid;
	_tmp76_ = image_settings;
	gtk_grid_attach (_tmp75_, (GtkWidget*) _tmp76_, 0, 0, 1, 1);
	_tmp77_ = menu_popover_grid;
	_tmp78_ = mirror_menuitem;
	gtk_grid_attach (_tmp77_, (GtkWidget*) _tmp78_, 0, 1, 1, 1);
	_tmp79_ = menu_popover_grid;
	gtk_widget_show_all ((GtkWidget*) _tmp79_);
	_tmp80_ = (GtkPopover*) gtk_popover_new (NULL);
	g_object_ref_sink (_tmp80_);
	popover = _tmp80_;
	_tmp81_ = popover;
	_tmp82_ = menu_popover_grid;
	gtk_container_add ((GtkContainer*) _tmp81_, (GtkWidget*) _tmp82_);
	_tmp83_ = (GtkImage*) gtk_image_new_from_icon_name ("open-menu-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp83_);
	_tmp84_ = popover;
	_tmp85_ = _g_object_ref0 (_tmp84_);
	_tmp86_ = g_strdup (_ ("Settings"));
	_tmp87_ = (GtkMenuButton*) gtk_menu_button_new ();
	gtk_button_set_image ((GtkButton*) _tmp87_, (GtkWidget*) _tmp83_);
	_g_object_unref0 (_tmp83_);
	gtk_menu_button_set_popover (_tmp87_, _tmp85_);
	_g_object_unref0 (_tmp85_);
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp87_, _tmp86_);
	_g_free0 (_tmp86_);
	g_object_ref_sink (_tmp87_);
	menu_button = _tmp87_;
	_tmp88_ = (GtkMenuButton*) gtk_menu_button_new ();
	g_object_ref_sink (_tmp88_);
	_g_object_unref0 (self->priv->camera_menu_button);
	self->priv->camera_menu_button = _tmp88_;
	_tmp89_ = (GtkMenu*) gtk_menu_new ();
	g_object_ref_sink (_tmp89_);
	_g_object_unref0 (self->priv->camera_options);
	self->priv->camera_options = _tmp89_;
	_tmp90_ = self->priv->camera_options;
	_tmp91_ = _g_object_ref0 (_tmp90_);
	_tmp92_ = (GtkMenuButton*) gtk_menu_button_new ();
	gtk_menu_button_set_popup (_tmp92_, _tmp91_);
	_g_object_unref0 (_tmp91_);
	g_object_ref_sink (_tmp92_);
	_g_object_unref0 (self->priv->camera_menu_button);
	self->priv->camera_menu_button = _tmp92_;
	_tmp93_ = self->priv->camera_menu_button;
	_tmp94_ = gtk_widget_get_style_context ((GtkWidget*) _tmp93_);
	camera_menu_button_style_context = _tmp94_;
	_tmp95_ = camera_menu_button_style_context;
	_tmp96_ = take_button_style_provider;
	gtk_style_context_add_provider (_tmp95_, (GtkStyleProvider*) _tmp96_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
	_tmp97_ = camera_menu_button_style_context;
	gtk_style_context_add_class (_tmp97_, GTK_STYLE_CLASS_DESTRUCTIVE_ACTION);
	_tmp98_ = camera_menu_button_style_context;
	gtk_style_context_add_class (_tmp98_, "camera-menu");
	_tmp99_ = (GtkRevealer*) gtk_revealer_new ();
	gtk_revealer_set_transition_duration (_tmp99_, (guint) 250);
	gtk_revealer_set_transition_type (_tmp99_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_RIGHT);
	g_object_ref_sink (_tmp99_);
	_g_object_unref0 (self->priv->camera_menu_revealer);
	self->priv->camera_menu_revealer = _tmp99_;
	_tmp100_ = self->priv->camera_menu_revealer;
	_tmp101_ = self->priv->camera_menu_button;
	gtk_container_add ((GtkContainer*) _tmp100_, (GtkWidget*) _tmp101_);
	_tmp102_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp102_);
	linked_box = _tmp102_;
	_tmp103_ = linked_box;
	_tmp104_ = self->priv->take_button;
	gtk_container_add ((GtkContainer*) _tmp103_, (GtkWidget*) _tmp104_);
	_tmp105_ = linked_box;
	_tmp106_ = self->priv->camera_menu_revealer;
	gtk_container_add ((GtkContainer*) _tmp105_, (GtkWidget*) _tmp106_);
	gtk_header_bar_set_show_close_button ((GtkHeaderBar*) self, TRUE);
	_tmp107_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp107_, GTK_STYLE_CLASS_TITLEBAR);
	_tmp108_ = self->priv->timer_button;
	gtk_header_bar_pack_start ((GtkHeaderBar*) self, (GtkWidget*) _tmp108_);
	_tmp109_ = linked_box;
	gtk_header_bar_set_custom_title ((GtkHeaderBar*) self, (GtkWidget*) _tmp109_);
	_tmp110_ = menu_button;
	gtk_header_bar_pack_end ((GtkHeaderBar*) self, (GtkWidget*) _tmp110_);
	_tmp111_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
	g_object_ref_sink (_tmp111_);
	_tmp112_ = _tmp111_;
	gtk_header_bar_pack_end ((GtkHeaderBar*) self, (GtkWidget*) _tmp112_);
	_g_object_unref0 (_tmp112_);
	_tmp113_ = self->priv->mode_switch;
	gtk_header_bar_pack_end ((GtkHeaderBar*) self, (GtkWidget*) _tmp113_);
	_tmp114_ = camera_application_settings;
	g_signal_connect_object (_tmp114_, "changed::mode", (GCallback) __camera_widgets_header_bar___lambda16__g_settings_changed, self, 0);
	_tmp115_ = self->priv->mode_switch;
	g_signal_connect_object ((GObject*) _tmp115_, "notify::active", (GCallback) __camera_widgets_header_bar___lambda17__g_object_notify, self, 0);
	g_signal_connect_object ((GObject*) self, "notify::recording", (GCallback) __camera_widgets_header_bar___lambda18__g_object_notify, self, 0);
	_tmp116_ = self->priv->mode_switch;
	_tmp117_ = camera_application_settings;
	granite_mode_switch_set_active (_tmp116_, g_settings_get_enum (_tmp117_, "mode") == ((gint) CAMERA_UTILS_ACTION_TYPE_VIDEO));
	_g_object_unref0 (linked_box);
	_g_object_unref0 (menu_button);
	_g_object_unref0 (popover);
	_g_object_unref0 (menu_popover_grid);
	_g_object_unref0 (image_settings);
	_g_object_unref0 (constrast_label);
	_g_object_unref0 (contrast_image);
	_g_object_unref0 (brightness_label);
	_g_object_unref0 (brightness_image);
	_g_object_unref0 (mirror_menuitem);
	_g_object_unref0 (mirror_grid);
	_g_object_unref0 (mirror_label);
	_g_object_unref0 (take_button_style_provider);
	_g_object_unref0 (take_grid);
	block6_data_unref (_data6_);
	_data6_ = NULL;
	return obj;
}

static void
camera_widgets_header_bar_class_init (CameraWidgetsHeaderBarClass * klass,
                                      gpointer klass_data)
{
	camera_widgets_header_bar_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &CameraWidgetsHeaderBar_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_camera_widgets_header_bar_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_camera_widgets_header_bar_set_property;
	G_OBJECT_CLASS (klass)->constructor = camera_widgets_header_bar_constructor;
	G_OBJECT_CLASS (klass)->finalize = camera_widgets_header_bar_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), CAMERA_WIDGETS_HEADER_BAR_RECORDING_PROPERTY, camera_widgets_header_bar_properties[CAMERA_WIDGETS_HEADER_BAR_RECORDING_PROPERTY] = g_param_spec_boolean ("recording", "recording", "recording", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), CAMERA_WIDGETS_HEADER_BAR_HORIZONTAL_FLIP_PROPERTY, camera_widgets_header_bar_properties[CAMERA_WIDGETS_HEADER_BAR_HORIZONTAL_FLIP_PROPERTY] = g_param_spec_boolean ("horizontal-flip", "horizontal-flip", "horizontal-flip", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), CAMERA_WIDGETS_HEADER_BAR_TIMER_DELAY_PROPERTY, camera_widgets_header_bar_properties[CAMERA_WIDGETS_HEADER_BAR_TIMER_DELAY_PROPERTY] = g_param_spec_int ("timer-delay", "timer-delay", "timer-delay", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	camera_widgets_header_bar_signals[CAMERA_WIDGETS_HEADER_BAR_REQUEST_CHANGE_BALANCE_SIGNAL] = g_signal_new ("request-change-balance", CAMERA_WIDGETS_TYPE_HEADER_BAR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__DOUBLE_DOUBLE, G_TYPE_NONE, 2, G_TYPE_DOUBLE, G_TYPE_DOUBLE);
	camera_widgets_header_bar_signals[CAMERA_WIDGETS_HEADER_BAR_REQUEST_CAMERA_CHANGE_SIGNAL] = g_signal_new ("request-camera-change", CAMERA_WIDGETS_TYPE_HEADER_BAR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
}

static void
camera_widgets_header_bar_instance_init (CameraWidgetsHeaderBar * self,
                                         gpointer klass)
{
	self->priv = camera_widgets_header_bar_get_instance_private (self);
	self->priv->_recording = FALSE;
	self->priv->_horizontal_flip = TRUE;
	self->priv->recording_timeout = 0U;
}

static void
camera_widgets_header_bar_finalize (GObject * obj)
{
	CameraWidgetsHeaderBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CAMERA_WIDGETS_TYPE_HEADER_BAR, CameraWidgetsHeaderBar);
	_g_object_unref0 (self->priv->timer_button);
	_g_object_unref0 (self->priv->video_timer_revealer);
	_g_object_unref0 (self->priv->take_timer);
	_g_object_unref0 (self->priv->take_button);
	_g_object_unref0 (self->priv->camera_menu_button);
	_g_object_unref0 (self->priv->camera_menu_revealer);
	_g_object_unref0 (self->priv->camera_options);
	_g_object_unref0 (self->priv->take_image);
	_g_object_unref0 (self->priv->mode_switch);
	G_OBJECT_CLASS (camera_widgets_header_bar_parent_class)->finalize (obj);
}

static GType
camera_widgets_header_bar_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (CameraWidgetsHeaderBarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) camera_widgets_header_bar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CameraWidgetsHeaderBar), 0, (GInstanceInitFunc) camera_widgets_header_bar_instance_init, NULL };
	GType camera_widgets_header_bar_type_id;
	camera_widgets_header_bar_type_id = g_type_register_static (gtk_header_bar_get_type (), "CameraWidgetsHeaderBar", &g_define_type_info, 0);
	CameraWidgetsHeaderBar_private_offset = g_type_add_instance_private (camera_widgets_header_bar_type_id, sizeof (CameraWidgetsHeaderBarPrivate));
	return camera_widgets_header_bar_type_id;
}

GType
camera_widgets_header_bar_get_type (void)
{
	static volatile gsize camera_widgets_header_bar_type_id__volatile = 0;
	if (g_once_init_enter (&camera_widgets_header_bar_type_id__volatile)) {
		GType camera_widgets_header_bar_type_id;
		camera_widgets_header_bar_type_id = camera_widgets_header_bar_get_type_once ();
		g_once_init_leave (&camera_widgets_header_bar_type_id__volatile, camera_widgets_header_bar_type_id);
	}
	return camera_widgets_header_bar_type_id__volatile;
}

static void
_vala_camera_widgets_header_bar_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec)
{
	CameraWidgetsHeaderBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CAMERA_WIDGETS_TYPE_HEADER_BAR, CameraWidgetsHeaderBar);
	switch (property_id) {
		case CAMERA_WIDGETS_HEADER_BAR_RECORDING_PROPERTY:
		g_value_set_boolean (value, camera_widgets_header_bar_get_recording (self));
		break;
		case CAMERA_WIDGETS_HEADER_BAR_HORIZONTAL_FLIP_PROPERTY:
		g_value_set_boolean (value, camera_widgets_header_bar_get_horizontal_flip (self));
		break;
		case CAMERA_WIDGETS_HEADER_BAR_TIMER_DELAY_PROPERTY:
		g_value_set_int (value, camera_widgets_header_bar_get_timer_delay (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_camera_widgets_header_bar_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec)
{
	CameraWidgetsHeaderBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CAMERA_WIDGETS_TYPE_HEADER_BAR, CameraWidgetsHeaderBar);
	switch (property_id) {
		case CAMERA_WIDGETS_HEADER_BAR_RECORDING_PROPERTY:
		camera_widgets_header_bar_set_recording (self, g_value_get_boolean (value));
		break;
		case CAMERA_WIDGETS_HEADER_BAR_HORIZONTAL_FLIP_PROPERTY:
		camera_widgets_header_bar_set_horizontal_flip (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

